/*****************************************************************************
    :   DS18B20, DS1820 (DS18S20)  +   ATmega644
    : 0.1
       : 16.04_17.2009
      : Nemo
e-mail      : no-op@ya.ru

       : ATmega644
  : 12 
----------------------------------------------
Fuse Bits: CKSEL0 = 0;
                SUT1 = 0;
	      WDTON = 0;
	      BODLEVEL1 = 0;
******************************************************************************/
#define version 1 // *10

#include <mega644.h>
#include <delay.h>
#include <stdio.h>
#include <string.h>

// 1 Wire Bus functions
#asm
   .equ __w1_port=0x05 ;PORTB
   .equ __w1_bit=4
#endasm
#include <1wire.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x08 ;PORTC
#endasm
#include <lcd4x40.h> //LCD driver routines

// I2C Bus functions
#asm
   .equ __i2c_port=0x0B ;PORTD
   .equ __sda_bit=5
   .equ __scl_bit=6
#endasm
#include <i2c.h>
#include <ds1307.h>

#define RX_BUFFER_SIZE 8 // USART Receiver buffer
#define MAX_DEVICES 4 // maximum number of DS18B20 connected to the 1 Wire bus

#define RED_LED PORTB.6
#define LCD_CONNECT PIND.7
#define GREEN_LED PORTB.7
#define NEW_TIME PIND.4

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
char lcd_buffer[40]; //     LCD
char rom_code [MAX_DEVICES][9]; // DS18B20 devices ROM code storage area
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
char rx_buffer[RX_BUFFER_SIZE]; //  RX UART
char tx_data [RX_BUFFER_SIZE]; //  TX UART
char tx_a [RX_BUFFER_SIZE]; //   TX UART  
char rx_wr_index; //   
char h, m, s, date, month, year; //    RTC DS1307
char devices; // 
char n_crc_error; //      crc rom 
char rom_error; //      rom 
char no_sensor; //  
char sensor_crc_error; // crc 
char sensor_type; // : 0 - DS18B20, 1 - DS18S20
char no_t_sensor; //  1 -  
char n_no_t_sensor; //    t-

unsigned long int temp_buffer [MAX_DEVICES]; //   

bit rxerror_cl; //  
bit rxerror; //  RX
bit rx_error_crc; //  RX CRC
bit rx_error_head; //  RX 
bit wire1_no; //    
//bit menu_f; //  
bit rx_temp; //   UART+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

 flash char ruscoder[64] = { //    ASCII  KOI-8R-----------------------------------------------------
 0x41, 0xA0, 0x42, 0xA1, //0xC0...0xC3 <=>    
 0xE0, 0x45, 0xA3, 0x33, //0xC4...0xC7 <=>    
 0xA5, 0xA6, 0x4B, 0xA7, //0xC8...0xCB <=>    
 0x4D, 0x48, 0x4F, 0xA8, //0xCC...0xCF <=>    

 0x50, 0x43, 0x54, 0xA9, //0xD0...0xD4 <=>     
 0xAA, 0x58, 0xE1, 0xAB, //0xD5...0xD7 <=>     
 0xAC, 0xE2, 0xAC, 0xAE, //0xD8...0xDB <=>     
 0x62, 0xAF, 0xB0, 0xB1, //0xDC...0xDF <=>     

 0x61, 0xB2, 0xB3, 0xB4, //0xE0...0xE4 <=>     
 0xE3, 0x65, 0xB6, 0xB7, //0xE5...0xE7 <=>     
 0xB8, 0xA6, 0xBA, 0xBB, //0xE8...0xEB <=>     
 0xBC, 0xBD, 0x6F, 0xBE, //0xEC...0xEF <=>     

 0x70, 0x63, 0xBF, 0x79, //0xF0...0xE4 <=>     
 0xE4, 0xD5, 0xE5, 0xC0, //0xF5...0xE7 <=>     
 0xC1, 0xE6, 0xC2, 0xC3, //0xF8...0xEB <=>     
 0XC4, 0xC5, 0xC6, 0xC7  //0xFC...0xEF <=>     
 };

 void __lcd_ruscoder_puts (char *message) //  ASCII  KOI-8R    LCD-----------------
{ //sprintf (message, " ! :)"); //   sprintf -   ASCII  ,    0   
 char i, j; //   

 j = strlen(message); //  

 for (i = 0; i < (j + 1); i++) // ASCII   KOI-8R, j + 1 -      - 0
     {
      if (message [i] > 192) // 
	     {
	      message [i] = ruscoder [(message [i] - 192)]; //  
	      };
	  };

 lcd_puts (message); //  LCD
 } //--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

void __io_init () //  /-----------------------------------------
{
 DDRA = 0b00000000; //  
 PORTA = 0b11111111;

 DDRB = 0b11000000; //7,6  
 PORTB = 0b11111111;

 DDRC = 0b00000000; //  
 PORTC = 0b11111111;

 DDRD = 0b00000000; //  
 PORTD = 0b11111111;

 // Analog Comparator initialization
 // Analog Comparator: Off
 // Analog Comparator Input Capture by Timer/Counter 1: Off
 ACSR=0x80;
 } //--------------------------------------------------------------------------------------------------------------------

void __watchdog_init () //    0,5 -----
{
// Watchdog Timer initialization
// Watchdog Timer Prescaler: OSC/64k
// Watchdog Timer interrupt: Off
#pragma optsize-
#asm("wdr")
WDTCSR=0x1D;
WDTCSR=0x0D;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif
} //-------------------------------------------------------------------------------------------------

void __usart_init () // USART----
{
 // USART0 initialization
 // Communication Parameters: 8 Data, 1 Stop, No Parity
 // USART0 Receiver: On
 // USART0 Transmitter: On
 // USART0 Mode: Asynchronous
 // USART0 Baud Rate: 57600
 UCSR0B = 0x98;
 UCSR0C = 0x86;
 UBRR0H = 0x00;
 UBRR0L = 0x0C;
 } //-----------------------------------------------------------------

void __rtc_init_gotoxy (char x, char y) //x  = 32, y = 0     rtc---
{
 lcd_gotoxy (x, y); // 
 lcd_putsf ("  :  :");

  lcd_gotoxy (x, y + 1); // 
 lcd_putsf ("  /  /  ");
 } //------------------------------------------------------------------------------------------------------------------------------------------

void __rtc_lcd_gotoxy (char x, char y) //x  = 32, y = 0          LCD----
{
 char rtc_buffer [4];
 // ------------------------------
 rtc_get_time(&h, &m, &s); //read time from the DS1307 RTC

 if (s < 10) //      
    {
     sprintf (rtc_buffer, "0%u", s); //   
     }
 else {
         sprintf (rtc_buffer, "%u", s);
         };

 lcd_gotoxy (x + 6, y); // 
 lcd_puts (rtc_buffer);

 if (m < 10)
    {
     sprintf (rtc_buffer, "0%u", m); //   
     }
 else {
         sprintf (rtc_buffer, "%u", m);
         };

 lcd_gotoxy (x + 3, y); // 
 lcd_puts (rtc_buffer);

 if (h < 10)
    {
     sprintf (rtc_buffer, " %u", h); //   
     }
 else {
         sprintf (rtc_buffer, "%u", h);
         };

 lcd_gotoxy (x, y);
 lcd_puts (rtc_buffer); // 

 // -----------
 rtc_get_date (&date, &month, &year); // 

 if (date < 10)
    {
     sprintf (rtc_buffer, " %u", date); //   
     }
 else {
         sprintf (rtc_buffer, "%u", date);
         };

 lcd_gotoxy (x, y + 1); // 
 lcd_puts (rtc_buffer);

 if (month < 10)
    {
     sprintf (rtc_buffer, "0%u", month); //   
     }
 else {
       sprintf (rtc_buffer, "%u", month);
       };

 lcd_gotoxy (x + 3, y + 1); // 
 lcd_puts (rtc_buffer);

 if (year < 10)
    {
     sprintf (rtc_buffer, "0%u", year); //   
     }
 else {
       sprintf (rtc_buffer, "%u", year);
       };

 lcd_gotoxy (x + 6, y + 1); // 
 lcd_puts (rtc_buffer);
} //---------------------------------------------------------------------------------------------------------------------------------------------------------

void __interrupt_init () // 
{
// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
// Interrupt on any change on pins PCINT0-7: On
// Interrupt on any change on pins PCINT8-15: Off
// Interrupt on any change on pins PCINT16-23: Off
// Interrupt on any change on pins PCINT24-31: Off
/*PCMSK0=0x1F;
PCICR=0x01;
PCIFR=0x01;*/

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK0 = 1;
}

char __byte_length (char data) //      v2 (   :)
{
char temp; // 
char i; //  
char body = 0; //   

for (i = 0; i < 8; i++) //  
    {
     temp = data & (1 << i); // 0- 

	 if (temp) //  -    1
	    {
		 body++;
         };
	};
return body;
}

char __adc_n_read (char n) //   ADC   n 
{
char data;    

i2c_start();
i2c_write(0b10010000); //, ,  
i2c_write(0b01000000 | n); //   
i2c_stop();

delay_ms(1);

i2c_start();
i2c_write(0b10010001); //, ,  
data = i2c_read(1); //   ACK    
data = i2c_read(0); //   ACK
i2c_stop();          

return data;
}

void __dac_write (unsigned char data) //    DAC 
{
i2c_start();
i2c_write(0b10010000);
i2c_write(0b01000000);
i2c_write(data);
i2c_stop();
}

interrupt [PCINT0] void __pin_change_isr0(void) //    PA0 - PA7********************
{

 } //**************************************************************************************************************************

 // USART Receiver interrupt service routine************************************************************************************************************
interrupt [USART0_RXC] void __usart0_rx_isr(void) //          
{
char j; // 

char s_w, m_w, h_w, date_w, month_w, year_w;; //  rtc

rx_buffer[rx_wr_index] = UDR0; //  

if (rx_wr_index == 0) // 0  /256,          8- 
   {
    TCCR0B = 4; //~5,44   
    };

if ((rx_wr_index == 7)&(rx_buffer [0] == 0xa1)&(rx_buffer [7] == w1_dow_crc8(rx_buffer, 7))) //     A1   CRC 
   {
	TCCR0B = 0; // 
	TCNT0 = 0; // 

	switch (rx_buffer [1]) //  
		   {
			case 1: tx_a [1] = 1; //: , 
					tx_a [2] = version; //  
					tx_a [2] = tx_a [2] | (rx_temp << 7); //  rx_temp
					tx_a [3] = devices; //  
			break;

			case 2: if (rx_buffer [2] == 1) //     
					   {
						rx_temp = 1; //     UART
						tx_a [1] = 2; //:     UART
						tx_a [2] = 1; //    UART
					    };

					if (rx_buffer [2] == 0)
					   {
						rx_temp = 0; //     UART
						tx_a [1] = 2; //:     UART
						tx_a [2] = 0; //     UART
						};
			break;
			// rtc
			case 3:  s_w = rx_buffer [2] & 0b00111111; // 

					 m_w = ((rx_buffer [2] >> 6) & 0b00000011) | ((rx_buffer [3] << 2) & 0b00111100); // 

					 h_w = ((rx_buffer [3] >> 4) & 0b00001111) | ((rx_buffer [4] << 4) & 0b00010000); // 

					 rtc_set_time (h_w, m_w, s_w); // 

					 rtc_get_time(&h, &m, &s); //read time from the DS1307 RTC

					 year_w = rx_buffer [4] >> 1; // 

					 month_w = rx_buffer [5] & 0b00001111; // 

					 date_w = ((rx_buffer [5] >> 4) & 0b00001111) | ((rx_buffer [6] << 4) & 0b00010000); // 

					 rtc_set_date (date_w, month_w, year_w); // 

					 rtc_get_date (&date, &month, &year); // 

					 tx_a [1] = 4; // , 4 - 

					 if ((s_w == s) & (m_w == m) & (h_w == h) & (year_w == year) & (month_w == month) & (date_w == date)) //    
					    {
					     tx_a [2] = 1; //rtc 
						 }
					 else {
					       tx_a [2] = 0; //rtc 
						   };
			break;
			};

	tx_a [7] = w1_dow_crc8(tx_a, 7); // CRC

	for (j = 0; j < 8; j++)
		{
		 putchar (tx_a [j]); //  
		 };

	rx_wr_index = 0; // 

	rxerror_cl = 1; //   
	}
else {
	  rx_wr_index++; //  

	  if (rx_wr_index == 8) // ,       
		 {
		  rx_wr_index = 0; //  

		  rxerror = 1; //  
		  rxerror_cl = 0; //   

		  if (!(rx_buffer [7] == w1_dow_crc8(rx_buffer, 7))) //   CRC
		     {
			  rx_error_crc = 1; //  crc
			  };

		  if (!(rx_buffer [0] == 0xa1)) //   
		     {
			  rx_error_head = 1; //  
			  };
		  };
	  };
} //***********************************************************************************************************************************************

// Timer 0 overflow interrupt service routine******************************
interrupt [TIM0_OVF] void __timer0_ovf_isr(void) //    -    < 8- 
{
 rx_wr_index = 0; //  

 TCCR0B = 0; // 
 TCNT0 = 0; // 
} //*****************************************************************

void main ()
{
char i, j, k; // 
char error_delay_counter = 0;
char data [9]; //  SRAM DS18B20
unsigned long int temp, temp2; // 

bit rtc_r = 1; //    rtc

//--------------------------------------------
char dac_counter = 0;
bit dac_counter_course = 0;
char adc_data [4];
//--------------------------------------------

__watchdog_init (); //    0,52 

__io_init (); // 

lcd_init (); // LCD

i2c_init (); // initialize the I2C bus

rtc_init (0, 1, 0); //initialize the DS1307 RTC

//
rtc_set_time (1, 2, 3);

rtc_set_date (4, 5, 6);
//

__usart_init (); // USART Baud Rate: 57600

__interrupt_init (); //  

__rtc_init_gotoxy (32, 0); //   rtc

lcd_gotoxy (36, 3); //  
sprintf (lcd_buffer, "v%u.%u", version/10, version%10);
lcd_puts (lcd_buffer);

//-------------------------------------
lcd_gotoxy (30, 3);
lcd_putsf ("-DAC");

lcd_gotoxy (20, 0);
lcd_putsf ("-ADC0");

lcd_gotoxy (20, 1);
lcd_putsf ("-ADC1");

lcd_gotoxy (20, 2);
lcd_putsf ("-ADC2");

lcd_gotoxy (20, 3);
lcd_putsf ("-ADC3");
//-------------------------------------

tx_data [0] = 0xa2;  // 
tx_a [0] = 0xa2;  // 
tx_data [1] = 0x03; //:  , , 

GREEN_LED = 0; // 
#asm ("wdr"); //  
devices = w1_search (0xf0, rom_code); //   
GREEN_LED = 1;

#asm ("sei"); //  

if (devices) //   
   {
    for (k = 0; k < devices; k++) // crc rom 
	{
	 if (!(w1_dow_crc8(rom_code [k], 7) == rom_code [k][7])) //   CRC   "t#- CRC_R!"
	    {
	     rom_error |= 1 << k; //   

		 sprintf (lcd_buffer, "t%u- CRC_R!", k + 1);
		 lcd_gotoxy (0, k);
		 __lcd_ruscoder_puts (lcd_buffer);
         }
	 else { //   crc
	       switch (rom_code [k][0]) //  
		          {
				   case 0x10: sensor_type |= (1 << k); // DS18S20 //0x10!!!!!

				   break;

				   case 0x28: sensor_type &= (~(1 << k)); // DS18B20
				   break;

				   default: no_t_sensor |= (1 << k); //,   

							sprintf (lcd_buffer, "t%u-  t-!", k + 1);
		                    lcd_gotoxy (0, k);
		                    __lcd_ruscoder_puts (lcd_buffer);
				   }
		   };
	 };
    n_crc_error = __byte_length (rom_error); //     crc rom 

	n_no_t_sensor = __byte_length (no_t_sensor); //   t-
	}
else { // ,   "1-Wire  !"
      wire1_no = 1;

	  lcd_gotoxy (0, 0);
	  lcd_putsf ("1-Wire");

	  sprintf (lcd_buffer, "");
	  lcd_gotoxy (2, 1);
	  __lcd_ruscoder_puts (lcd_buffer);

	  sprintf (lcd_buffer, "!");
	  lcd_gotoxy (11, 2);
	  __lcd_ruscoder_puts (lcd_buffer);
	  };

i = 0;

while (1) // 
      {
	   if (__byte_length (no_sensor) == (devices - n_no_t_sensor)); //  ,      -----------------------------
	   else
		  { //  
           w1_init(); //
           w1_write (0xcc); //SKIP ROM [CCh]    

           w1_write (0x44); //CONVERT T [44h]   

           while (!w1_read ()) //  
              {
               delay_ms (70);

	           /*if ((!NEW_TIME) & rtc_r) //  ,      ----
	              {
		           __rtc_lcd_gotoxy (32, 0); //   

		           rtc_r = 0;
		           };

		       if (!NEW_TIME) //       
		          {
		           rtc_r = 1;
			       };*/ //------------------------------------------------------------------------------------------------------------------
	            };
		   }; //-------------------------------------------------------------------------------------------------------------------------------------------------

	   if (error_delay_counter >= i) //        
	   {
	   GREEN_LED = 0; // 

	   for (k = 0; k < devices; k++) //   =====================================================
	       {
			if ((rom_error & (1 << k)) | (no_t_sensor & (1 << k))); //  CRC ROM     
		    else //  
			{
	        w1_init(); //
		    w1_write (0x55); //MATCH ROM [55h]   k- 

            for (j = 0; j < 8; j++) // rom  k- 
                {
	             w1_write (rom_code [k][j]);
	             };

	        w1_write (0xbe); //READ SCRATCHPAD [BEh]   

            for (j = 0; j < 9; j++) // SCRATCHPAD
		        {
		  	     data [j] = w1_read (); // 
			    };



		    // --------------------------------------------------------------------------------------------------------------
		    if ((data [6] == 255) & (data [7] == 255)) //  ,  "t#-  !"
		       {
		        no_sensor |= 1 << k; //   

		        sprintf (lcd_buffer, "t%u-  !", k + 1);
		        lcd_gotoxy (0, k);
		        __lcd_ruscoder_puts (lcd_buffer);
		        }
		    else { // CRC
		          i = w1_dow_crc8(data, 8); // CRC

		          if (!(i == data [8])) //   CRC   "t#-  CRC! "
                     {
                      sensor_crc_error |= 1 << k; //   

			          sprintf (lcd_buffer, "t%u-  CRC! ", k + 1);
			          lcd_gotoxy (0, k);
			          __lcd_ruscoder_puts (lcd_buffer);
			          }
		          else { // crc ,   :)
						if (sensor_crc_error & (1 << k)) // crc ,   
						   {
						    sensor_crc_error &= 0 << k;
							};

						if (no_sensor & (1 << k)) //  ,   
						   {
						    no_sensor &= 0 << k;
							};
                        //  --------------------------------------------------------
						if (sensor_type & (1 << k)) //  
						{ //DS18S20
						 tx_data [2] = k; //  k- 
                         tx_data [4] = 1; //   DS18S20

						 if (data [1] == 0xff) //  
						    {
							 tx_data [2] = tx_data [2] | 0b00010000; //  

							 data [0] = ~ data [0];

							 temp = data [0] >> 1;

						     temp *= 10000;

						     temp -= 7500;

						     temp2 = data [6];

						     temp2 *= 10000;

						     temp2 /= data [7];

						     temp += temp2;
							 //temp /= 2;
							 }
					     else
						 {
						 temp = data [0] >> 1;

						 temp *= 10000;

						 temp += 7500;

						 temp2 = data [6];

						 temp2 *= 10000;

						 temp2 /= data [7];

						 temp -= temp2;
						 };

						 if (data [1] == 0xff) //  
				            {
				             i = '-'; //  "-"
				             }
                         else {
				               i = '+'; //  "+"
					           };

						 j = '_'; //   DS18S20
						 
						 lcd_gotoxy (15, k); // 
						 lcd_putsf (" ");
						 }
						else
						{ //DS18B20
						tx_data [4] = 0; //   DS18B20

						i = (data [1] & 0b11111000) >> 3; //  

			            tx_data [2] = k; //  k- 

			            if (i == 31) //  
				           {
				            tx_data [2] = tx_data [2] | 0b00010000; //  

				            data [0] = ~ data [0];
				            data [1] = ~ data [1];
				            };

		                temp = data [1];

		                temp &= 0b00000111; //       3   

		                temp <<= 8;

		                temp |= data [0]; // 12-  

			            if (i == 31) //  
				           {
				            temp++;
				            i = '-'; //  "-"
				            }
                        else {
				              i = '+'; //  "+"
					          };

						if (temp > temp_buffer [k]) // -------------------------
						   {
						    lcd_gotoxy (15, k);

							if (i == 45) // ""
							   {
							    lcd_putsf ("\xda"); //  
							    }
							else {
							      lcd_putsf ("\xd9"); //  
								  };
						    };

						if (temp < temp_buffer [k])
						   {
			                lcd_gotoxy (15, k);

							if (i == 45) // ""
							   {
							    lcd_putsf ("\xd9"); //  
							    }
							else {
							      lcd_putsf ("\xda"); //  
								  };
							};

						if (temp == temp_buffer [k])
						   {
			                lcd_gotoxy (15, k);
							lcd_putsf (" "); // 
							};

						temp_buffer [k] = temp; //     

		                temp *= 625; //  --------------------------------------------------------

						j = ' ';
						};

						//-----------------------------------------------------------------------------------------------------------------------------------
                        sprintf (lcd_buffer, "t%u=%c%c%", k + 1, j, i); // 
                        lcd_gotoxy (0, k); //  
		                lcd_puts (lcd_buffer);

						i = temp/10000; //      

						sprintf (lcd_buffer, "%u.%04u  ", i, temp%10000); // 
						//     ,         
						if (i < 10)
						   {
						    j = 7;

							lcd_gotoxy (5, k); //  
		                    lcd_putsf ("  ");
							};

						if (i >= 10)
						   {
						    j = 6;

							lcd_gotoxy (5, k); //  
		                    lcd_putsf (" ");
							};

						if (i >= 100)
						   {
						    j = 5;
							};

						lcd_gotoxy (j, k); //  
		                lcd_puts (lcd_buffer);

						lcd_gotoxy (13, k);
						lcd_putsf ("\xdfC"); //---------------------------------------------------------------------------------------------------------

                        //  USART------------------------------------------------
			            if (rx_temp) //   
		                   {
			                tx_data [2] = tx_data [2] | (data [0] << 5); // 3   

			                tx_data [3] = 0; //  

			                tx_data [3] = tx_data [3] | (data [0] >> 3); // 5  
			                tx_data [3] = tx_data [3] | (data [1] << 5); // 3   

			                tx_data [7] = w1_dow_crc8(tx_data, 7); // CRC

		                    for (i = 0; i < 8; i++) //   USART
		                        {
			                     putchar (tx_data [i]);
			                     };
                            }; //----------------------------------------------------------
			            }; //-------------------------------------------------------------------------------------------------------
                 };
		    };
			};

			GREEN_LED = 1; //  
		}; //==============================================================================================================

	   if ((!NEW_TIME) & rtc_r) //  ,      ---
	      {
		   __rtc_lcd_gotoxy (32, 0); //   

		   rtc_r = 0;
		   };

		if (!NEW_TIME) //       
		   {
		    rtc_r = 1;
			}; //---------------------------------------------------------------------------------------------------------------

	   // ===============================================================================
	   if (((n_crc_error == devices) & (!wire1_no)) | (n_no_t_sensor == devices)) // crc rom      t- 
	      {
		   error_delay_counter++;
		   i = 1;

		   if (error_delay_counter > 30)
		      {
		       RED_LED ^= 1;

			   error_delay_counter = 0;
			   }
		   delay_ms (10);
		   }
       else {
	         i = 0;
			 };

	   if (rom_error * (!(n_crc_error == devices))) // crc rom    
	      {
		   if (no_sensor | sensor_crc_error); //         "t#-  ", "t#-  CRC  "
		   else {
		         RED_LED ^= 1;
				 };
           };

	   if (no_t_sensor * (!(n_no_t_sensor == devices))) // t-,  
	      {
		   if (no_sensor | sensor_crc_error); //         "t#-  ", "t#-  CRC  "
		   else {
		         RED_LED ^= 1;
				 };
		   };

	   if (no_sensor | sensor_crc_error) // "t#-  ", "t#-  CRC  "
	      {
		   if ((__byte_length (no_sensor) == (devices - n_no_t_sensor)) | (__byte_length (sensor_crc_error) == (devices - n_no_t_sensor))) //   
		      {
			   error_delay_counter++; //     1-Wire

			   i = 30; //  1-Wire  0,3

			   if (error_delay_counter > 30)
		          {
		           RED_LED ^= 1; // 
			       error_delay_counter = 0; //      1-Wire
				   };
			   delay_ms (10); //        1-Wire
			   }
		   else { //    
		         RED_LED ^= 1;
				 };
		   };

	   if (wire1_no) // "1-Wire  !"
	      {
		   error_delay_counter++;

		   switch (error_delay_counter)
		          {
		           case 50: RED_LED = 0;
				   break;

				   case 60: RED_LED = 1;
				   break;

				   case 70: RED_LED = 0;
				   break;

				   case 80: RED_LED = 1;
				   break;

				   case 90: RED_LED = 0;
				   break;

				   case 100: RED_LED = 1;
				             error_delay_counter = 0;
				   break;
		           };

		   delay_ms (10); //  
		   };

	   if ( no_sensor | sensor_crc_error | rom_error | wire1_no | i | no_t_sensor);//  ,    
       else {
             RED_LED = 1;
		     i = 0; //   1-Wire
			 };

	   if (rxerror_cl) //   ,   --------------------------
	      {
           rxerror_cl = 0;

	       lcd_gotoxy (21, 2);
		   lcd_putsf ("                   "); //  
	       };

	   if (rxerror) //  
	      {
		   rxerror = 0;

		   sprintf (lcd_buffer, " RX "); //  
           lcd_gotoxy (21, 2);
		   __lcd_ruscoder_puts (lcd_buffer);
	       };

	   if (rx_error_crc & rx_error_head) //    crc
	      {
		   rx_error_crc = 0;
		   rx_error_head = 0;

		   sprintf (lcd_buffer, "-,CRC");
		   lcd_gotoxy (31, 2);
		   __lcd_ruscoder_puts (lcd_buffer);
		   }
	   else {
	         if (rx_error_crc)
	            {
		         rx_error_crc = 0;

		         lcd_gotoxy (31, 2);
		         lcd_putsf ("CRC      "); // "CRC"
		         };

	         if (rx_error_head)
	            {
		         rx_error_head = 0;

		         sprintf (lcd_buffer, ""); // ""
		         lcd_gotoxy (31, 2);
		         __lcd_ruscoder_puts (lcd_buffer);
		         };
             }; //===================================================================================

		// I2C----------------------------------------
		//  DAC
		__dac_write (dac_counter);
		
		lcd_gotoxy (26, 3); // DAC
		lcd_putsf ("   ");

		sprintf (lcd_buffer, "%u", dac_counter);
		lcd_gotoxy (26, 3);
		lcd_puts (lcd_buffer);
        
		if (dac_counter == 0)
		   {
		    dac_counter_course = 0;

			lcd_gotoxy (29, 3); //  
			lcd_putsf ("\xd9");
			};

		if (dac_counter == 255)
		   {
			dac_counter_course = 1;

			lcd_gotoxy (29, 3); //  
			lcd_putsf ("\xda");
			};

		if (dac_counter_course)
		   {
		    dac_counter--;
		    }
		else {
		      dac_counter++;
		      };
		
		//  ADC
		for (j = 0; j < 4; j++)
	       {
			adc_data [j] = __adc_n_read(j);
			};
	   
	    for (j = 0; j < 4; j++)
	        {
	         lcd_gotoxy (17, j); // ADC
	         lcd_putsf ("   ");
	         sprintf (lcd_buffer, "%u", adc_data [j]);
	         lcd_gotoxy (17, j);
	         lcd_puts (lcd_buffer);
	         };
		//---------------------------------------------------------	
		};
 }