
#pragma used+
sfrb PINA=0;
sfrb DDRA=1;
sfrb PORTA=2;
sfrb PINB=3;
sfrb DDRB=4;
sfrb PORTB=5;
sfrb PINC=6;
sfrb DDRC=7;
sfrb PORTC=8;
sfrb PIND=9;
sfrb DDRD=0xa;
sfrb PORTD=0xb;
sfrb TIFR0=0x15;
sfrb TIFR1=0x16;
sfrb TIFR2=0x17;
sfrb PCIFR=0x1b;
sfrb EIFR=0x1c;
sfrb EIMSK=0x1d;
sfrb GPIOR0=0x1e;
sfrb EECR=0x1f;
sfrb EEDR=0x20;
sfrb EEARL=0x21;
sfrb EEARH=0x22;
sfrw EEAR=0X21;   
sfrb GTCCR=0x23;
sfrb TCCR0A=0x24;
sfrb TCCR0B=0x25;
sfrb TCNT0=0x26;
sfrb OCR0A=0x27;
sfrb OCR0B=0x28;
sfrb GPIOR1=0x2a;
sfrb GPIOR2=0x2b;
sfrb SPCR0=0x2c;
sfrb SPSR0=0x2d;
sfrb SPDR0=0x2e;
sfrb ACSR=0x30;
sfrb OCDR=0x31;
sfrb SMCR=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb RAMPZ=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.EQU __sm_adc_noise_red=0x02
	.SET power_ctrl_reg=smcr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

char *strcat(char *str1,char *str2);
char *strcatf(char *str1,char flash *str2);
char *strchr(char *str,char c);
signed char strcmp(char *str1,char *str2);
signed char strcmpf(char *str1,char flash *str2);
char *strcpy(char *dest,char *src);
char *strcpyf(char *dest,char flash *src);
unsigned int strlenf(char flash *str);
char *strncat(char *str1,char *str2,unsigned char n);
char *strncatf(char *str1,char flash *str2,unsigned char n);
signed char strncmp(char *str1,char *str2,unsigned char n);
signed char strncmpf(char *str1,char flash *str2,unsigned char n);
char *strncpy(char *dest,char *src,unsigned char n);
char *strncpyf(char *dest,char flash *src,unsigned char n);
char *strpbrk(char *str,char *set);
char *strpbrkf(char *str,char flash *set);
char *strrchr(char *str,char c);
char *strrpbrk(char *str,char *set);
char *strrpbrkf(char *str,char flash *set);
char *strstr(char *str1,char *str2);
char *strstrf(char *str1,char flash *str2);
char *strtok(char *str1,char flash *str2);

unsigned int strlen(char *str);
void *memccpy(void *dest,void *src,char c,unsigned n);
void *memchr(void *buf,unsigned char c,unsigned n);
signed char memcmp(void *buf1,void *buf2,unsigned n);
signed char memcmpf(void *buf1,void flash *buf2,unsigned n);
void *memcpy(void *dest,void *src,unsigned n);
void *memcpyf(void *dest,void flash *src,unsigned n);
void *memmove(void *dest,void *src,unsigned n);
void *memset(void *buf,unsigned char c,unsigned n);
unsigned int strcspn(char *str,char *set);
unsigned int strcspnf(char *str,char flash *set);
int strpos(char *str,char c);
int strrpos(char *str,char c);
unsigned int strspn(char *str,char *set);
unsigned int strspnf(char *str,char flash *set);

#pragma used-
#pragma library string.lib

#asm
   .equ __w1_port=0x05 ;PORTB
   .equ __w1_bit=4
#endasm

#pragma used+
unsigned char w1_init(void);
unsigned char w1_read(void);
unsigned char w1_write(unsigned char data);
unsigned char w1_search(unsigned char cmd,void *p);
unsigned char w1_dow_crc8(void *p,unsigned char n);
#pragma used-

#asm
   .equ __lcd_port=0x08 ;PORTC
#endasm

#pragma used+

extern unsigned char _en1_msk;

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);

void lcd_write_byte(unsigned char addr, unsigned char data);

unsigned char lcd_read_byte(unsigned char addr);

void lcd_gotoxy(unsigned char x, unsigned char y);

void lcd_clear(void);
void lcd_putchar(char c);

void lcd_puts(char *str);

void lcd_putsf(char flash *str);

unsigned char lcd_init(void);

#pragma used-
#pragma library lcd4x40.lib

#asm
   .equ __i2c_port=0x0B ;PORTD
   .equ __sda_bit=5
   .equ __scl_bit=6
#endasm

#pragma used+
void i2c_init(void);
unsigned char i2c_start(void);
void i2c_stop(void);
unsigned char i2c_read(unsigned char ack);
unsigned char i2c_write(unsigned char data);
#pragma used-

#pragma used+

unsigned char rtc_read(unsigned char address);
void rtc_write(unsigned char address,unsigned char data);
void rtc_init(unsigned char rs,unsigned char sqwe,unsigned char out);
void rtc_get_time(unsigned char *hour,unsigned char *min,unsigned char *sec);
void rtc_set_time(unsigned char hour,unsigned char min,unsigned char sec);
void rtc_get_date(unsigned char *date,unsigned char *month,unsigned char *year);
void rtc_set_date(unsigned char date,unsigned char month,unsigned char year);

#pragma used-
#pragma library ds1307.lib

char lcd_buffer[40]; 
char rom_code [4 ][9]; 

char rx_buffer[8 ]; 
char tx_data [8 ]; 
char tx_a [8 ]; 
char rx_wr_index; 
char h, m, s, date, month, year; 
char devices; 
char n_crc_error; 
char rom_error; 
char no_sensor; 
char sensor_crc_error; 
char sensor_type; 
char no_t_sensor; 
char n_no_t_sensor; 

unsigned long int temp_buffer [4 ]; 

bit rxerror_cl; 
bit rxerror; 
bit rx_error_crc; 
bit rx_error_head; 
bit wire1_no; 

bit rx_temp; 

flash char ruscoder[64] = { 
0x41, 0xA0, 0x42, 0xA1, 
0xE0, 0x45, 0xA3, 0x33, 
0xA5, 0xA6, 0x4B, 0xA7, 
0x4D, 0x48, 0x4F, 0xA8, 

0x50, 0x43, 0x54, 0xA9, 
0xAA, 0x58, 0xE1, 0xAB, 
0xAC, 0xE2, 0xAC, 0xAE, 
0x62, 0xAF, 0xB0, 0xB1, 

0x61, 0xB2, 0xB3, 0xB4, 
0xE3, 0x65, 0xB6, 0xB7, 
0xB8, 0xA6, 0xBA, 0xBB, 
0xBC, 0xBD, 0x6F, 0xBE, 

0x70, 0x63, 0xBF, 0x79, 
0xE4, 0xD5, 0xE5, 0xC0, 
0xC1, 0xE6, 0xC2, 0xC3, 
0XC4, 0xC5, 0xC6, 0xC7  
};

void __lcd_ruscoder_puts (char *message) 
{ 
char i, j; 

j = strlen(message); 

for (i = 0; i < (j + 1); i++) 
{
if (message [i] > 192) 
{
message [i] = ruscoder [(message [i] - 192)]; 
};
};

lcd_puts (message); 
} 

void __io_init () 
{
DDRA = 0b00000000; 
PORTA = 0b11111111;

DDRB = 0b11000000; 
PORTB = 0b11111111;

DDRC = 0b00000000; 
PORTC = 0b11111111;

DDRD = 0b00000000; 
PORTD = 0b11111111;

ACSR=0x80;
} 

void __watchdog_init () 
{

#pragma optsize-
#asm("wdr")
(*(unsigned char *) 0x60)=0x1D;
(*(unsigned char *) 0x60)=0x0D;
#pragma optsize+
} 

void __usart_init () 
{

(*(unsigned char *) 0xc1) = 0x98;
(*(unsigned char *) 0xc2) = 0x86;
(*(unsigned char *) 0xc5) = 0x00;
(*(unsigned char *) 0xc4) = 0x0C;
} 

void __rtc_init_gotoxy (char x, char y) 
{
lcd_gotoxy (x, y); 
lcd_putsf ("  :  :");

lcd_gotoxy (x, y + 1); 
lcd_putsf ("  /  /  ");
} 

void __rtc_lcd_gotoxy (char x, char y) 
{
char rtc_buffer [4];

rtc_get_time(&h, &m, &s); 

if (s < 10) 
{
sprintf (rtc_buffer, "0%u", s); 
}
else {
sprintf (rtc_buffer, "%u", s);
};

lcd_gotoxy (x + 6, y); 
lcd_puts (rtc_buffer);

if (m < 10)
{
sprintf (rtc_buffer, "0%u", m); 
}
else {
sprintf (rtc_buffer, "%u", m);
};

lcd_gotoxy (x + 3, y); 
lcd_puts (rtc_buffer);

if (h < 10)
{
sprintf (rtc_buffer, " %u", h); 
}
else {
sprintf (rtc_buffer, "%u", h);
};

lcd_gotoxy (x, y);
lcd_puts (rtc_buffer); 

rtc_get_date (&date, &month, &year); 

if (date < 10)
{
sprintf (rtc_buffer, " %u", date); 
}
else {
sprintf (rtc_buffer, "%u", date);
};

lcd_gotoxy (x, y + 1); 
lcd_puts (rtc_buffer);

if (month < 10)
{
sprintf (rtc_buffer, "0%u", month); 
}
else {
sprintf (rtc_buffer, "%u", month);
};

lcd_gotoxy (x + 3, y + 1); 
lcd_puts (rtc_buffer);

if (year < 10)
{
sprintf (rtc_buffer, "0%u", year); 
}
else {
sprintf (rtc_buffer, "%u", year);
};

lcd_gotoxy (x + 6, y + 1); 
lcd_puts (rtc_buffer);
} 

void __interrupt_init () 
{

(*(unsigned char *) 0x6e) = 1;
}

char __byte_length (char data) 
{
char temp; 
char i; 
char body = 0; 

for (i = 0; i < 8; i++) 
{
temp = data & (1 << i); 

if (temp) 
{
body++;
};
};
return body;
}

char __adc_n_read (char n) 
{
char data;    

i2c_start();
i2c_write(0b10010000); 
i2c_write(0b01000000 | n); 
i2c_stop();

delay_ms(1);

i2c_start();
i2c_write(0b10010001); 
data = i2c_read(1); 
data = i2c_read(0); 
i2c_stop();          

return data;
}

void __dac_write (unsigned char data) 
{
i2c_start();
i2c_write(0b10010000);
i2c_write(0b01000000);
i2c_write(data);
i2c_stop();
}

interrupt [5] void __pin_change_isr0(void) 
{

} 

interrupt [21] void __usart0_rx_isr(void) 
{
char j; 

char s_w, m_w, h_w, date_w, month_w, year_w;; 

rx_buffer[rx_wr_index] = (*(unsigned char *) 0xc6); 

if (rx_wr_index == 0) 
{
TCCR0B = 4; 
};

if ((rx_wr_index == 7)&(rx_buffer [0] == 0xa1)&(rx_buffer [7] == w1_dow_crc8(rx_buffer, 7))) 
{
TCCR0B = 0; 
TCNT0 = 0; 

switch (rx_buffer [1]) 
{
case 1: tx_a [1] = 1; 
tx_a [2] = 1 ; 
tx_a [2] = tx_a [2] | (rx_temp << 7); 
tx_a [3] = devices; 
break;

case 2: if (rx_buffer [2] == 1) 
{
rx_temp = 1; 
tx_a [1] = 2; 
tx_a [2] = 1; 
};

if (rx_buffer [2] == 0)
{
rx_temp = 0; 
tx_a [1] = 2; 
tx_a [2] = 0; 
};
break;

case 3:  s_w = rx_buffer [2] & 0b00111111; 

m_w = ((rx_buffer [2] >> 6) & 0b00000011) | ((rx_buffer [3] << 2) & 0b00111100); 

h_w = ((rx_buffer [3] >> 4) & 0b00001111) | ((rx_buffer [4] << 4) & 0b00010000); 

rtc_set_time (h_w, m_w, s_w); 

rtc_get_time(&h, &m, &s); 

year_w = rx_buffer [4] >> 1; 

month_w = rx_buffer [5] & 0b00001111; 

date_w = ((rx_buffer [5] >> 4) & 0b00001111) | ((rx_buffer [6] << 4) & 0b00010000); 

rtc_set_date (date_w, month_w, year_w); 

rtc_get_date (&date, &month, &year); 

tx_a [1] = 4; 

if ((s_w == s) & (m_w == m) & (h_w == h) & (year_w == year) & (month_w == month) & (date_w == date)) 
{
tx_a [2] = 1; 
}
else {
tx_a [2] = 0; 
};
break;
};

tx_a [7] = w1_dow_crc8(tx_a, 7); 

for (j = 0; j < 8; j++)
{
putchar (tx_a [j]); 
};

rx_wr_index = 0; 

rxerror_cl = 1; 
}
else {
rx_wr_index++; 

if (rx_wr_index == 8) 
{
rx_wr_index = 0; 

rxerror = 1; 
rxerror_cl = 0; 

if (!(rx_buffer [7] == w1_dow_crc8(rx_buffer, 7))) 
{
rx_error_crc = 1; 
};

if (!(rx_buffer [0] == 0xa1)) 
{
rx_error_head = 1; 
};
};
};
} 

interrupt [19] void __timer0_ovf_isr(void) 
{
rx_wr_index = 0; 

TCCR0B = 0; 
TCNT0 = 0; 
} 

void main ()
{
char i, j, k; 
char error_delay_counter = 0;
char data [9]; 
unsigned long int temp, temp2; 

bit rtc_r = 1; 

char dac_counter = 0;
bit dac_counter_course = 0;
char adc_data [4];

__watchdog_init (); 

__io_init (); 

lcd_init (); 

i2c_init (); 

rtc_init (0, 1, 0); 

rtc_set_time (1, 2, 3);

rtc_set_date (4, 5, 6);

__usart_init (); 

__interrupt_init (); 

__rtc_init_gotoxy (32, 0); 

lcd_gotoxy (36, 3); 
sprintf (lcd_buffer, "v%u.%u", 1 /10, 1 %10);
lcd_puts (lcd_buffer);

lcd_gotoxy (30, 3);
lcd_putsf ("-DAC");

lcd_gotoxy (20, 0);
lcd_putsf ("-ADC0");

lcd_gotoxy (20, 1);
lcd_putsf ("-ADC1");

lcd_gotoxy (20, 2);
lcd_putsf ("-ADC2");

lcd_gotoxy (20, 3);
lcd_putsf ("-ADC3");

tx_data [0] = 0xa2;  
tx_a [0] = 0xa2;  
tx_data [1] = 0x03; 

PORTB.7 = 0; 
#asm ("wdr"); 
devices = w1_search (0xf0, rom_code); 
PORTB.7 = 1;

#asm ("sei"); 

if (devices) 
{
for (k = 0; k < devices; k++) 
{
if (!(w1_dow_crc8(rom_code [k], 7) == rom_code [k][7])) 
{
rom_error |= 1 << k; 

sprintf (lcd_buffer, "t%u- CRC_R!", k + 1);
lcd_gotoxy (0, k);
__lcd_ruscoder_puts (lcd_buffer);
}
else { 
switch (rom_code [k][0]) 
{
case 0x10: sensor_type |= (1 << k); 

break;

case 0x28: sensor_type &= (~(1 << k)); 
break;

default: no_t_sensor |= (1 << k); 

sprintf (lcd_buffer, "t%u-  t-!", k + 1);
lcd_gotoxy (0, k);
__lcd_ruscoder_puts (lcd_buffer);
}
};
};
n_crc_error = __byte_length (rom_error); 

n_no_t_sensor = __byte_length (no_t_sensor); 
}
else { 
wire1_no = 1;

lcd_gotoxy (0, 0);
lcd_putsf ("1-Wire");

sprintf (lcd_buffer, "");
lcd_gotoxy (2, 1);
__lcd_ruscoder_puts (lcd_buffer);

sprintf (lcd_buffer, "!");
lcd_gotoxy (11, 2);
__lcd_ruscoder_puts (lcd_buffer);
};

i = 0;

while (1) 
{
if (__byte_length (no_sensor) == (devices - n_no_t_sensor)); 
else
{ 
w1_init(); 
w1_write (0xcc); 

w1_write (0x44); 

while (!w1_read ()) 
{
delay_ms (70);

};
}; 

if (error_delay_counter >= i) 
{
PORTB.7 = 0; 

for (k = 0; k < devices; k++) 
{
if ((rom_error & (1 << k)) | (no_t_sensor & (1 << k))); 
else 
{
w1_init(); 
w1_write (0x55); 

for (j = 0; j < 8; j++) 
{
w1_write (rom_code [k][j]);
};

w1_write (0xbe); 

for (j = 0; j < 9; j++) 
{
data [j] = w1_read (); 
};

if ((data [6] == 255) & (data [7] == 255)) 
{
no_sensor |= 1 << k; 

sprintf (lcd_buffer, "t%u-  !", k + 1);
lcd_gotoxy (0, k);
__lcd_ruscoder_puts (lcd_buffer);
}
else { 
i = w1_dow_crc8(data, 8); 

if (!(i == data [8])) 
{
sensor_crc_error |= 1 << k; 

sprintf (lcd_buffer, "t%u-  CRC! ", k + 1);
lcd_gotoxy (0, k);
__lcd_ruscoder_puts (lcd_buffer);
}
else { 
if (sensor_crc_error & (1 << k)) 
{
sensor_crc_error &= 0 << k;
};

if (no_sensor & (1 << k)) 
{
no_sensor &= 0 << k;
};

if (sensor_type & (1 << k)) 
{ 
tx_data [2] = k; 
tx_data [4] = 1; 

if (data [1] == 0xff) 
{
tx_data [2] = tx_data [2] | 0b00010000; 

data [0] = ~ data [0];

temp = data [0] >> 1;

temp *= 10000;

temp -= 7500;

temp2 = data [6];

temp2 *= 10000;

temp2 /= data [7];

temp += temp2;

}
else
{
temp = data [0] >> 1;

temp *= 10000;

temp += 7500;

temp2 = data [6];

temp2 *= 10000;

temp2 /= data [7];

temp -= temp2;
};

if (data [1] == 0xff) 
{
i = '-'; 
}
else {
i = '+'; 
};

j = '_'; 

lcd_gotoxy (15, k); 
lcd_putsf (" ");
}
else
{ 
tx_data [4] = 0; 

i = (data [1] & 0b11111000) >> 3; 

tx_data [2] = k; 

if (i == 31) 
{
tx_data [2] = tx_data [2] | 0b00010000; 

data [0] = ~ data [0];
data [1] = ~ data [1];
};

temp = data [1];

temp &= 0b00000111; 

temp <<= 8;

temp |= data [0]; 

if (i == 31) 
{
temp++;
i = '-'; 
}
else {
i = '+'; 
};

if (temp > temp_buffer [k]) 
{
lcd_gotoxy (15, k);

if (i == 45) 
{
lcd_putsf ("\xda"); 
}
else {
lcd_putsf ("\xd9"); 
};
};

if (temp < temp_buffer [k])
{
lcd_gotoxy (15, k);

if (i == 45) 
{
lcd_putsf ("\xd9"); 
}
else {
lcd_putsf ("\xda"); 
};
};

if (temp == temp_buffer [k])
{
lcd_gotoxy (15, k);
lcd_putsf (" "); 
};

temp_buffer [k] = temp; 

temp *= 625; 

j = ' ';
};

sprintf (lcd_buffer, "t%u=%c%c%", k + 1, j, i); 
lcd_gotoxy (0, k); 
lcd_puts (lcd_buffer);

i = temp/10000; 

sprintf (lcd_buffer, "%u.%04u  ", i, temp%10000); 

if (i < 10)
{
j = 7;

lcd_gotoxy (5, k); 
lcd_putsf ("  ");
};

if (i >= 10)
{
j = 6;

lcd_gotoxy (5, k); 
lcd_putsf (" ");
};

if (i >= 100)
{
j = 5;
};

lcd_gotoxy (j, k); 
lcd_puts (lcd_buffer);

lcd_gotoxy (13, k);
lcd_putsf ("\xdfC"); 

if (rx_temp) 
{
tx_data [2] = tx_data [2] | (data [0] << 5); 

tx_data [3] = 0; 

tx_data [3] = tx_data [3] | (data [0] >> 3); 
tx_data [3] = tx_data [3] | (data [1] << 5); 

tx_data [7] = w1_dow_crc8(tx_data, 7); 

for (i = 0; i < 8; i++) 
{
putchar (tx_data [i]);
};
}; 
}; 
};
};
};

PORTB.7 = 1; 
}; 

if ((!PIND.4) & rtc_r) 
{
__rtc_lcd_gotoxy (32, 0); 

rtc_r = 0;
};

if (!PIND.4) 
{
rtc_r = 1;
}; 

if (((n_crc_error == devices) & (!wire1_no)) | (n_no_t_sensor == devices)) 
{
error_delay_counter++;
i = 1;

if (error_delay_counter > 30)
{
PORTB.6 ^= 1;

error_delay_counter = 0;
}
delay_ms (10);
}
else {
i = 0;
};

if (rom_error * (!(n_crc_error == devices))) 
{
if (no_sensor | sensor_crc_error); 
else {
PORTB.6 ^= 1;
};
};

if (no_t_sensor * (!(n_no_t_sensor == devices))) 
{
if (no_sensor | sensor_crc_error); 
else {
PORTB.6 ^= 1;
};
};

if (no_sensor | sensor_crc_error) 
{
if ((__byte_length (no_sensor) == (devices - n_no_t_sensor)) | (__byte_length (sensor_crc_error) == (devices - n_no_t_sensor))) 
{
error_delay_counter++; 

i = 30; 

if (error_delay_counter > 30)
{
PORTB.6 ^= 1; 
error_delay_counter = 0; 
};
delay_ms (10); 
}
else { 
PORTB.6 ^= 1;
};
};

if (wire1_no) 
{
error_delay_counter++;

switch (error_delay_counter)
{
case 50: PORTB.6 = 0;
break;

case 60: PORTB.6 = 1;
break;

case 70: PORTB.6 = 0;
break;

case 80: PORTB.6 = 1;
break;

case 90: PORTB.6 = 0;
break;

case 100: PORTB.6 = 1;
error_delay_counter = 0;
break;
};

delay_ms (10); 
};

if ( no_sensor | sensor_crc_error | rom_error | wire1_no | i | no_t_sensor);
else {
PORTB.6 = 1;
i = 0; 
};

if (rxerror_cl) 
{
rxerror_cl = 0;

lcd_gotoxy (21, 2);
lcd_putsf ("                   "); 
};

if (rxerror) 
{
rxerror = 0;

sprintf (lcd_buffer, " RX "); 
lcd_gotoxy (21, 2);
__lcd_ruscoder_puts (lcd_buffer);
};

if (rx_error_crc & rx_error_head) 
{
rx_error_crc = 0;
rx_error_head = 0;

sprintf (lcd_buffer, "-,CRC");
lcd_gotoxy (31, 2);
__lcd_ruscoder_puts (lcd_buffer);
}
else {
if (rx_error_crc)
{
rx_error_crc = 0;

lcd_gotoxy (31, 2);
lcd_putsf ("CRC      "); 
};

if (rx_error_head)
{
rx_error_head = 0;

sprintf (lcd_buffer, ""); 
lcd_gotoxy (31, 2);
__lcd_ruscoder_puts (lcd_buffer);
};
}; 

__dac_write (dac_counter);

lcd_gotoxy (26, 3); 
lcd_putsf ("   ");

sprintf (lcd_buffer, "%u", dac_counter);
lcd_gotoxy (26, 3);
lcd_puts (lcd_buffer);

if (dac_counter == 0)
{
dac_counter_course = 0;

lcd_gotoxy (29, 3); 
lcd_putsf ("\xd9");
};

if (dac_counter == 255)
{
dac_counter_course = 1;

lcd_gotoxy (29, 3); 
lcd_putsf ("\xda");
};

if (dac_counter_course)
{
dac_counter--;
}
else {
dac_counter++;
};

for (j = 0; j < 4; j++)
{
adc_data [j] = __adc_n_read(j);
};

for (j = 0; j < 4; j++)
{
lcd_gotoxy (17, j); 
lcd_putsf ("   ");
sprintf (lcd_buffer, "%u", adc_data [j]);
lcd_gotoxy (17, j);
lcd_puts (lcd_buffer);
};

};
}
