
;CodeVisionAVR C Compiler V2.03.4 Standard
;(C) Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega644
;Program type           : Application
;Clock frequency        : 12,000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : long, width, precision
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;global const stored in FLASH  : Yes
;8 bit enums            : Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega644
	#pragma AVRPART MEMORY PROG_FLASH 65536
	#pragma AVRPART MEMORY EEPROM 2048
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR0=0x2D
	.EQU SPDR0=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _rx_wr_index=R5
	.DEF _h=R4
	.DEF _m=R7
	.DEF _s=R6
	.DEF _date=R9
	.DEF _month=R8
	.DEF _year=R11
	.DEF _devices=R10
	.DEF _n_crc_error=R13
	.DEF _rom_error=R12

	.CSEG
	.ORG 0x00

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  ___pin_change_isr0
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  ___timer0_ovf_isr
	JMP  0x00
	JMP  ___usart0_rx_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_ruscoder:
	.DB  0x41,0xA0,0x42,0xA1,0xE0,0x45,0xA3,0x33
	.DB  0xA5,0xA6,0x4B,0xA7,0x4D,0x48,0x4F,0xA8
	.DB  0x50,0x43,0x54,0xA9,0xAA,0x58,0xE1,0xAB
	.DB  0xAC,0xE2,0xAC,0xAE,0x62,0xAF,0xB0,0xB1
	.DB  0x61,0xB2,0xB3,0xB4,0xE3,0x65,0xB6,0xB7
	.DB  0xB8,0xA6,0xBA,0xBB,0xBC,0xBD,0x6F,0xBE
	.DB  0x70,0x63,0xBF,0x79,0xE4,0xD5,0xE5,0xC0
	.DB  0xC1,0xE6,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7

;GPIOR0 INITIALIZATION
	.EQU  __GPIOR0_INIT=0x00

_0x0:
	.DB  0x20,0x20,0x3A,0x20,0x20,0x3A,0x0,0x20
	.DB  0x20,0x2F,0x20,0x20,0x2F,0x20,0x20,0x0
	.DB  0x30,0x25,0x75,0x0,0x20,0x25,0x75,0x0
	.DB  0x76,0x25,0x75,0x2E,0x25,0x75,0x0,0x2D
	.DB  0x44,0x41,0x43,0x0,0x2D,0x41,0x44,0x43
	.DB  0x30,0x0,0x2D,0x41,0x44,0x43,0x31,0x0
	.DB  0x2D,0x41,0x44,0x43,0x32,0x0,0x2D,0x41
	.DB  0x44,0x43,0x33,0x0,0x74,0x25,0x75,0x2D
	.DB  0xEE,0xF8,0xE8,0xE1,0xEA,0xE0,0x20,0x43
	.DB  0x52,0x43,0x5F,0x52,0x21,0x0,0x74,0x25
	.DB  0x75,0x2D,0x20,0xED,0xE5,0x20,0x74,0x2D
	.DB  0xE4,0xE0,0xF2,0xF7,0xE8,0xEA,0x21,0x0
	.DB  0x31,0x2D,0x57,0x69,0x72,0x65,0x0,0xF2
	.DB  0xE5,0xF0,0xEC,0xEE,0xE4,0xE0,0xF2,0xF7
	.DB  0xE8,0xEA,0xEE,0xE2,0x0,0xED,0xE5,0xF2
	.DB  0x21,0x0,0x74,0x25,0x75,0x2D,0x20,0xED
	.DB  0xE5,0xF2,0x20,0xE4,0xE0,0xF2,0xF7,0xE8
	.DB  0xEA,0xE0,0x21,0x0,0x74,0x25,0x75,0x2D
	.DB  0x20,0xEE,0xF8,0xE8,0xE1,0xEA,0xE0,0x20
	.DB  0x43,0x52,0x43,0x21,0x20,0x0,0xDA,0x0
	.DB  0xD9,0x0,0x74,0x25,0x75,0x3D,0x25,0x63
	.DB  0x25,0x63,0x25,0x0,0x25,0x75,0x2E,0x25
	.DB  0x30,0x34,0x75,0x20,0x20,0x0,0xDF,0x43
	.DB  0x0,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0xCE,0xF8,0xE8
	.DB  0xE1,0xEA,0xE0,0x20,0x52,0x58,0x20,0x0
	.DB  0xE7,0xE0,0x2D,0xEA,0xE0,0x2C,0x43,0x52
	.DB  0x43,0x0,0x43,0x52,0x43,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x0,0xE7,0xE0,0xE3,0xEE
	.DB  0xEB,0xEE,0xE2,0xEA,0xE0,0x0
__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500

	.CSEG
;/*****************************************************************************
;    :   DS18B20, DS1820 (DS18S20)  +   ATmega644
;    : 0.1
;       : 16.04_17.2009
;      : Nemo
;e-mail      : no-op@ya.ru
;
;       : ATmega644
;  : 12 
;----------------------------------------------
;Fuse Bits: CKSEL0 = 0;
;                SUT1 = 0;
;	      WDTON = 0;
;	      BODLEVEL1 = 0;
;******************************************************************************/
;#define version 1 // *10
;
;#include <mega644.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.EQU __sm_adc_noise_red=0x02
	.SET power_ctrl_reg=smcr
	#endif
;#include <delay.h>
;#include <stdio.h>
;#include <string.h>
;
;// 1 Wire Bus functions
;#asm
   .equ __w1_port=0x05 ;PORTB
   .equ __w1_bit=4
; 0000 001B #endasm
;#include <1wire.h>
;
;// Alphanumeric LCD Module functions
;#asm
   .equ __lcd_port=0x08 ;PORTC
; 0000 0021 #endasm
;#include <lcd4x40.h> //LCD driver routines
;
;// I2C Bus functions
;#asm
   .equ __i2c_port=0x0B ;PORTD
   .equ __sda_bit=5
   .equ __scl_bit=6
; 0000 0029 #endasm
;#include <i2c.h>
;#include <ds1307.h>
;
;#define RX_BUFFER_SIZE 8 // USART Receiver buffer
;#define MAX_DEVICES 4 // maximum number of DS18B20 connected to the 1 Wire bus
;
;#define RED_LED PORTB.6
;#define LCD_CONNECT PIND.7
;#define GREEN_LED PORTB.7
;#define NEW_TIME PIND.4
;
;//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;char lcd_buffer[40]; //     LCD
;char rom_code [MAX_DEVICES][9]; // DS18B20 devices ROM code storage area
;//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;char rx_buffer[RX_BUFFER_SIZE]; //  RX UART
;char tx_data [RX_BUFFER_SIZE]; //  TX UART
;char tx_a [RX_BUFFER_SIZE]; //   TX UART  
;char rx_wr_index; //   
;char h, m, s, date, month, year; //    RTC DS1307
;char devices; // 
;char n_crc_error; //      crc rom 
;char rom_error; //      rom 
;char no_sensor; //  
;char sensor_crc_error; // crc 
;char sensor_type; // : 0 - DS18B20, 1 - DS18S20
;char no_t_sensor; //  1 -  
;char n_no_t_sensor; //    t-
;
;unsigned long int temp_buffer [MAX_DEVICES]; //   
;
;bit rxerror_cl; //  
;bit rxerror; //  RX
;bit rx_error_crc; //  RX CRC
;bit rx_error_head; //  RX 
;bit wire1_no; //    
;//bit menu_f; //  
;bit rx_temp; //   UART+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
; flash char ruscoder[64] = { //    ASCII  KOI-8R-----------------------------------------------------
; 0x41, 0xA0, 0x42, 0xA1, //0xC0...0xC3 <=>    
; 0xE0, 0x45, 0xA3, 0x33, //0xC4...0xC7 <=>    
; 0xA5, 0xA6, 0x4B, 0xA7, //0xC8...0xCB <=>    
; 0x4D, 0x48, 0x4F, 0xA8, //0xCC...0xCF <=>    
;
; 0x50, 0x43, 0x54, 0xA9, //0xD0...0xD4 <=>     
; 0xAA, 0x58, 0xE1, 0xAB, //0xD5...0xD7 <=>     
; 0xAC, 0xE2, 0xAC, 0xAE, //0xD8...0xDB <=>     
; 0x62, 0xAF, 0xB0, 0xB1, //0xDC...0xDF <=>     
;
; 0x61, 0xB2, 0xB3, 0xB4, //0xE0...0xE4 <=>     
; 0xE3, 0x65, 0xB6, 0xB7, //0xE5...0xE7 <=>     
; 0xB8, 0xA6, 0xBA, 0xBB, //0xE8...0xEB <=>     
; 0xBC, 0xBD, 0x6F, 0xBE, //0xEC...0xEF <=>     
;
; 0x70, 0x63, 0xBF, 0x79, //0xF0...0xE4 <=>     
; 0xE4, 0xD5, 0xE5, 0xC0, //0xF5...0xE7 <=>     
; 0xC1, 0xE6, 0xC2, 0xC3, //0xF8...0xEB <=>     
; 0XC4, 0xC5, 0xC6, 0xC7  //0xFC...0xEF <=>     
; };
;
; void __lcd_ruscoder_puts (char *message) //  ASCII  KOI-8R    LCD-----------------
; 0000 0068 { //sprintf (message, " ! :)"); //   sprintf -   ASCII  ,    0   

	.CSEG
___lcd_ruscoder_puts:
; 0000 0069  char i, j; //   
; 0000 006A 
; 0000 006B  j = strlen(message); //  
	ST   -Y,R17
	ST   -Y,R16
;	*message -> Y+2
;	i -> R17
;	j -> R16
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R16,R30
; 0000 006C 
; 0000 006D  for (i = 0; i < (j + 1); i++) // ASCII   KOI-8R, j + 1 -      - 0
	LDI  R17,LOW(0)
_0x4:
	MOV  R30,R16
	SUBI R30,-LOW(1)
	CP   R17,R30
	BRSH _0x5
; 0000 006E      {
; 0000 006F       if (message [i] > 192) // 
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R26,X
	CPI  R26,LOW(0xC1)
	BRLO _0x6
; 0000 0070 	     {
; 0000 0071 	      message [i] = ruscoder [(message [i] - 192)]; //  
	MOV  R30,R17
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	MOVW R0,R30
	CLR  R30
	ADD  R26,R17
	ADC  R27,R30
	LD   R30,X
	SUBI R30,LOW(192)
	LDI  R31,0
	SUBI R30,LOW(-_ruscoder*2)
	SBCI R31,HIGH(-_ruscoder*2)
	LPM  R30,Z
	MOVW R26,R0
	ST   X,R30
; 0000 0072 	      };
_0x6:
; 0000 0073 	  };
	SUBI R17,-1
	RJMP _0x4
_0x5:
; 0000 0074 
; 0000 0075  lcd_puts (message); //  LCD
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	CALL SUBOPT_0x0
; 0000 0076  } //--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	RET
;
;void __io_init () //  /-----------------------------------------
; 0000 0079 {
___io_init:
; 0000 007A  DDRA = 0b00000000; //  
	LDI  R30,LOW(0)
	OUT  0x1,R30
; 0000 007B  PORTA = 0b11111111;
	LDI  R30,LOW(255)
	OUT  0x2,R30
; 0000 007C 
; 0000 007D  DDRB = 0b11000000; //7,6  
	LDI  R30,LOW(192)
	OUT  0x4,R30
; 0000 007E  PORTB = 0b11111111;
	LDI  R30,LOW(255)
	OUT  0x5,R30
; 0000 007F 
; 0000 0080  DDRC = 0b00000000; //  
	LDI  R30,LOW(0)
	OUT  0x7,R30
; 0000 0081  PORTC = 0b11111111;
	LDI  R30,LOW(255)
	OUT  0x8,R30
; 0000 0082 
; 0000 0083  DDRD = 0b00000000; //  
	LDI  R30,LOW(0)
	OUT  0xA,R30
; 0000 0084  PORTD = 0b11111111;
	LDI  R30,LOW(255)
	OUT  0xB,R30
; 0000 0085 
; 0000 0086  // Analog Comparator initialization
; 0000 0087  // Analog Comparator: Off
; 0000 0088  // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 0089  ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
; 0000 008A  } //--------------------------------------------------------------------------------------------------------------------
	RET
;
;void __watchdog_init () //    0,5 -----
; 0000 008D {
___watchdog_init:
; 0000 008E // Watchdog Timer initialization
; 0000 008F // Watchdog Timer Prescaler: OSC/64k
; 0000 0090 // Watchdog Timer interrupt: Off
; 0000 0091 #pragma optsize-
; 0000 0092 #asm("wdr")
	wdr
; 0000 0093 WDTCSR=0x1D;
	LDI  R30,LOW(29)
	STS  96,R30
; 0000 0094 WDTCSR=0x0D;
	LDI  R30,LOW(13)
	STS  96,R30
; 0000 0095 #ifdef _OPTIMIZE_SIZE_
; 0000 0096 #pragma optsize+
; 0000 0097 #endif
; 0000 0098 } //-------------------------------------------------------------------------------------------------
	RET
;
;void __usart_init () // USART----
; 0000 009B {
___usart_init:
; 0000 009C  // USART0 initialization
; 0000 009D  // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 009E  // USART0 Receiver: On
; 0000 009F  // USART0 Transmitter: On
; 0000 00A0  // USART0 Mode: Asynchronous
; 0000 00A1  // USART0 Baud Rate: 57600
; 0000 00A2  UCSR0B = 0x98;
	LDI  R30,LOW(152)
	STS  193,R30
; 0000 00A3  UCSR0C = 0x86;
	LDI  R30,LOW(134)
	STS  194,R30
; 0000 00A4  UBRR0H = 0x00;
	LDI  R30,LOW(0)
	STS  197,R30
; 0000 00A5  UBRR0L = 0x0C;
	LDI  R30,LOW(12)
	STS  196,R30
; 0000 00A6  } //-----------------------------------------------------------------
	RET
;
;void __rtc_init_gotoxy (char x, char y) //x  = 32, y = 0     rtc---
; 0000 00A9 {
___rtc_init_gotoxy:
; 0000 00AA  lcd_gotoxy (x, y); // 
;	x -> Y+1
;	y -> Y+0
	LDD  R30,Y+1
	ST   -Y,R30
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _lcd_gotoxy
; 0000 00AB  lcd_putsf ("  :  :");
	__POINTW1FN _0x0,0
	CALL SUBOPT_0x1
; 0000 00AC 
; 0000 00AD   lcd_gotoxy (x, y + 1); // 
	LDD  R30,Y+1
	ST   -Y,R30
	LDD  R30,Y+1
	CALL SUBOPT_0x2
; 0000 00AE  lcd_putsf ("  /  /  ");
	__POINTW1FN _0x0,7
	CALL SUBOPT_0x1
; 0000 00AF  } //------------------------------------------------------------------------------------------------------------------------------------------
	RJMP _0x20C0009
;
;void __rtc_lcd_gotoxy (char x, char y) //x  = 32, y = 0          LCD----
; 0000 00B2 {
___rtc_lcd_gotoxy:
; 0000 00B3  char rtc_buffer [4];
; 0000 00B4  // ------------------------------
; 0000 00B5  rtc_get_time(&h, &m, &s); //read time from the DS1307 RTC
	SBIW R28,4
;	x -> Y+5
;	y -> Y+4
;	rtc_buffer -> Y+0
	CALL SUBOPT_0x3
; 0000 00B6 
; 0000 00B7  if (s < 10) //      
	LDI  R30,LOW(10)
	CP   R6,R30
	BRSH _0x7
; 0000 00B8     {
; 0000 00B9      sprintf (rtc_buffer, "0%u", s); //   
	CALL SUBOPT_0x4
	__POINTW1FN _0x0,16
	RJMP _0xD0
; 0000 00BA      }
; 0000 00BB  else {
_0x7:
; 0000 00BC          sprintf (rtc_buffer, "%u", s);
	CALL SUBOPT_0x4
	__POINTW1FN _0x0,17
_0xD0:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R6
	CALL SUBOPT_0x5
; 0000 00BD          };
; 0000 00BE 
; 0000 00BF  lcd_gotoxy (x + 6, y); // 
	LDD  R30,Y+5
	SUBI R30,-LOW(6)
	CALL SUBOPT_0x6
; 0000 00C0  lcd_puts (rtc_buffer);
; 0000 00C1 
; 0000 00C2  if (m < 10)
	LDI  R30,LOW(10)
	CP   R7,R30
	BRSH _0x9
; 0000 00C3     {
; 0000 00C4      sprintf (rtc_buffer, "0%u", m); //   
	CALL SUBOPT_0x4
	__POINTW1FN _0x0,16
	RJMP _0xD1
; 0000 00C5      }
; 0000 00C6  else {
_0x9:
; 0000 00C7          sprintf (rtc_buffer, "%u", m);
	CALL SUBOPT_0x4
	__POINTW1FN _0x0,17
_0xD1:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R7
	CALL SUBOPT_0x5
; 0000 00C8          };
; 0000 00C9 
; 0000 00CA  lcd_gotoxy (x + 3, y); // 
	LDD  R30,Y+5
	SUBI R30,-LOW(3)
	CALL SUBOPT_0x6
; 0000 00CB  lcd_puts (rtc_buffer);
; 0000 00CC 
; 0000 00CD  if (h < 10)
	LDI  R30,LOW(10)
	CP   R4,R30
	BRSH _0xB
; 0000 00CE     {
; 0000 00CF      sprintf (rtc_buffer, " %u", h); //   
	CALL SUBOPT_0x4
	__POINTW1FN _0x0,20
	RJMP _0xD2
; 0000 00D0      }
; 0000 00D1  else {
_0xB:
; 0000 00D2          sprintf (rtc_buffer, "%u", h);
	CALL SUBOPT_0x4
	__POINTW1FN _0x0,17
_0xD2:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R4
	CALL SUBOPT_0x5
; 0000 00D3          };
; 0000 00D4 
; 0000 00D5  lcd_gotoxy (x, y);
	LDD  R30,Y+5
	CALL SUBOPT_0x6
; 0000 00D6  lcd_puts (rtc_buffer); // 
; 0000 00D7 
; 0000 00D8  // -----------
; 0000 00D9  rtc_get_date (&date, &month, &year); // 
	CALL SUBOPT_0x7
; 0000 00DA 
; 0000 00DB  if (date < 10)
	LDI  R30,LOW(10)
	CP   R9,R30
	BRSH _0xD
; 0000 00DC     {
; 0000 00DD      sprintf (rtc_buffer, " %u", date); //   
	CALL SUBOPT_0x4
	__POINTW1FN _0x0,20
	RJMP _0xD3
; 0000 00DE      }
; 0000 00DF  else {
_0xD:
; 0000 00E0          sprintf (rtc_buffer, "%u", date);
	CALL SUBOPT_0x4
	__POINTW1FN _0x0,17
_0xD3:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R9
	CALL SUBOPT_0x5
; 0000 00E1          };
; 0000 00E2 
; 0000 00E3  lcd_gotoxy (x, y + 1); // 
	LDD  R30,Y+5
	CALL SUBOPT_0x8
; 0000 00E4  lcd_puts (rtc_buffer);
	CALL SUBOPT_0x9
; 0000 00E5 
; 0000 00E6  if (month < 10)
	LDI  R30,LOW(10)
	CP   R8,R30
	BRSH _0xF
; 0000 00E7     {
; 0000 00E8      sprintf (rtc_buffer, "0%u", month); //   
	CALL SUBOPT_0x4
	__POINTW1FN _0x0,16
	RJMP _0xD4
; 0000 00E9      }
; 0000 00EA  else {
_0xF:
; 0000 00EB        sprintf (rtc_buffer, "%u", month);
	CALL SUBOPT_0x4
	__POINTW1FN _0x0,17
_0xD4:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R8
	CALL SUBOPT_0x5
; 0000 00EC        };
; 0000 00ED 
; 0000 00EE  lcd_gotoxy (x + 3, y + 1); // 
	LDD  R30,Y+5
	SUBI R30,-LOW(3)
	CALL SUBOPT_0x8
; 0000 00EF  lcd_puts (rtc_buffer);
	CALL SUBOPT_0x9
; 0000 00F0 
; 0000 00F1  if (year < 10)
	LDI  R30,LOW(10)
	CP   R11,R30
	BRSH _0x11
; 0000 00F2     {
; 0000 00F3      sprintf (rtc_buffer, "0%u", year); //   
	CALL SUBOPT_0x4
	__POINTW1FN _0x0,16
	RJMP _0xD5
; 0000 00F4      }
; 0000 00F5  else {
_0x11:
; 0000 00F6        sprintf (rtc_buffer, "%u", year);
	CALL SUBOPT_0x4
	__POINTW1FN _0x0,17
_0xD5:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R11
	CALL SUBOPT_0x5
; 0000 00F7        };
; 0000 00F8 
; 0000 00F9  lcd_gotoxy (x + 6, y + 1); // 
	LDD  R30,Y+5
	SUBI R30,-LOW(6)
	CALL SUBOPT_0x8
; 0000 00FA  lcd_puts (rtc_buffer);
	CALL SUBOPT_0x9
; 0000 00FB } //---------------------------------------------------------------------------------------------------------------------------------------------------------
	ADIW R28,6
	RET
;
;void __interrupt_init () // 
; 0000 00FE {
___interrupt_init:
; 0000 00FF // External Interrupt(s) initialization
; 0000 0100 // INT0: Off
; 0000 0101 // INT1: Off
; 0000 0102 // INT2: Off
; 0000 0103 // Interrupt on any change on pins PCINT0-7: On
; 0000 0104 // Interrupt on any change on pins PCINT8-15: Off
; 0000 0105 // Interrupt on any change on pins PCINT16-23: Off
; 0000 0106 // Interrupt on any change on pins PCINT24-31: Off
; 0000 0107 /*PCMSK0=0x1F;
; 0000 0108 PCICR=0x01;
; 0000 0109 PCIFR=0x01;*/
; 0000 010A 
; 0000 010B // Timer(s)/Counter(s) Interrupt(s) initialization
; 0000 010C TIMSK0 = 1;
	LDI  R30,LOW(1)
	STS  110,R30
; 0000 010D }
	RET
;
;char __byte_length (char data) //      v2 (   :)
; 0000 0110 {
___byte_length:
; 0000 0111 char temp; // 
; 0000 0112 char i; //  
; 0000 0113 char body = 0; //   
; 0000 0114 
; 0000 0115 for (i = 0; i < 8; i++) //  
	CALL __SAVELOCR4
;	data -> Y+4
;	temp -> R17
;	i -> R16
;	body -> R19
	LDI  R19,0
	LDI  R16,LOW(0)
_0x14:
	CPI  R16,8
	BRSH _0x15
; 0000 0116     {
; 0000 0117      temp = data & (1 << i); // 0- 
	MOV  R30,R16
	LDI  R26,LOW(1)
	CALL __LSLB12
	LDD  R26,Y+4
	AND  R30,R26
	MOV  R17,R30
; 0000 0118 
; 0000 0119 	 if (temp) //  -    1
	CPI  R17,0
	BREQ _0x16
; 0000 011A 	    {
; 0000 011B 		 body++;
	SUBI R19,-1
; 0000 011C          };
_0x16:
; 0000 011D 	};
	SUBI R16,-1
	RJMP _0x14
_0x15:
; 0000 011E return body;
	MOV  R30,R19
	CALL __LOADLOCR4
	ADIW R28,5
	RET
; 0000 011F }
;
;char __adc_n_read (char n) //   ADC   n
; 0000 0122 {
___adc_n_read:
; 0000 0123 char data;
; 0000 0124 
; 0000 0125 i2c_start();
	ST   -Y,R17
;	n -> Y+1
;	data -> R17
	CALL SUBOPT_0xA
; 0000 0126 i2c_write(0b10010000); //, ,  
; 0000 0127 i2c_write(0b01000000 | n); //   
	LDD  R30,Y+1
	ORI  R30,0x40
	ST   -Y,R30
	CALL SUBOPT_0xB
; 0000 0128 i2c_stop();
; 0000 0129 
; 0000 012A delay_ms(1);
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CALL SUBOPT_0xC
; 0000 012B 
; 0000 012C i2c_start();
	CALL _i2c_start
; 0000 012D i2c_write(0b10010001); //, ,  
	LDI  R30,LOW(145)
	CALL SUBOPT_0xD
; 0000 012E data = i2c_read(1); //   ACK
	MOV  R17,R30
; 0000 012F data = i2c_read(0); //   ACK
	CALL SUBOPT_0xE
	MOV  R17,R30
; 0000 0130 i2c_stop();
	CALL _i2c_stop
; 0000 0131 
; 0000 0132 return data;
	MOV  R30,R17
	LDD  R17,Y+0
_0x20C0009:
	ADIW R28,2
	RET
; 0000 0133 }
;
;void __dac_write (unsigned char data) //    DAC
; 0000 0136 {
___dac_write:
; 0000 0137 i2c_start();
;	data -> Y+0
	CALL SUBOPT_0xA
; 0000 0138 i2c_write(0b10010000);
; 0000 0139 i2c_write(0b01000000);
	LDI  R30,LOW(64)
	ST   -Y,R30
	CALL _i2c_write
; 0000 013A i2c_write(data);
	LD   R30,Y
	ST   -Y,R30
	CALL SUBOPT_0xB
; 0000 013B i2c_stop();
; 0000 013C }
	ADIW R28,1
	RET
;
;interrupt [PCINT0] void __pin_change_isr0(void) //    PA0 - PA7********************
; 0000 013F {
___pin_change_isr0:
; 0000 0140 
; 0000 0141  } //**************************************************************************************************************************
	RETI
;
; // USART Receiver interrupt service routine************************************************************************************************************
;interrupt [USART0_RXC] void __usart0_rx_isr(void) //          
; 0000 0145 {
___usart0_rx_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R15
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 0146 char j; // 
; 0000 0147 
; 0000 0148 char s_w, m_w, h_w, date_w, month_w, year_w;; //  rtc
; 0000 0149 
; 0000 014A rx_buffer[rx_wr_index] = UDR0; //  
	SBIW R28,1
	CALL __SAVELOCR6
;	j -> R17
;	s_w -> R16
;	m_w -> R19
;	h_w -> R18
;	date_w -> R21
;	month_w -> R20
;	year_w -> Y+6
	MOV  R26,R5
	LDI  R27,0
	SUBI R26,LOW(-_rx_buffer)
	SBCI R27,HIGH(-_rx_buffer)
	LDS  R30,198
	ST   X,R30
; 0000 014B 
; 0000 014C if (rx_wr_index == 0) // 0  /256,          8- 
	TST  R5
	BRNE _0x17
; 0000 014D    {
; 0000 014E     TCCR0B = 4; //~5,44   
	LDI  R30,LOW(4)
	OUT  0x25,R30
; 0000 014F     };
_0x17:
; 0000 0150 
; 0000 0151 if ((rx_wr_index == 7)&(rx_buffer [0] == 0xa1)&(rx_buffer [7] == w1_dow_crc8(rx_buffer, 7))) //     A1   CRC 
	MOV  R26,R5
	LDI  R30,LOW(7)
	CALL __EQB12
	MOV  R0,R30
	LDS  R26,_rx_buffer
	LDI  R30,LOW(161)
	CALL __EQB12
	AND  R30,R0
	PUSH R30
	CALL SUBOPT_0xF
	CALL __EQB12
	POP  R26
	AND  R30,R26
	BRNE PC+3
	JMP _0x18
; 0000 0152    {
; 0000 0153 	TCCR0B = 0; // 
	LDI  R30,LOW(0)
	OUT  0x25,R30
; 0000 0154 	TCNT0 = 0; // 
	OUT  0x26,R30
; 0000 0155 
; 0000 0156 	switch (rx_buffer [1]) //  
	__GETB1MN _rx_buffer,1
; 0000 0157 		   {
; 0000 0158 			case 1: tx_a [1] = 1; //: , 
	CPI  R30,LOW(0x1)
	BRNE _0x1C
	LDI  R30,LOW(1)
	__PUTB1MN _tx_a,1
; 0000 0159 					tx_a [2] = version; //  
	__PUTB1MN _tx_a,2
; 0000 015A 					tx_a [2] = tx_a [2] | (rx_temp << 7); //  rx_temp
	LDI  R26,0
	SBIC 0x1E,5
	LDI  R26,1
	MOV  R30,R26
	ROR  R30
	LDI  R30,0
	ROR  R30
	__GETB2MN _tx_a,2
	OR   R30,R26
	__PUTB1MN _tx_a,2
; 0000 015B 					tx_a [3] = devices; //  
	__PUTBMRN _tx_a,3,10
; 0000 015C 			break;
	RJMP _0x1B
; 0000 015D 
; 0000 015E 			case 2: if (rx_buffer [2] == 1) //     
_0x1C:
	CPI  R30,LOW(0x2)
	BRNE _0x1D
	__GETB1MN _rx_buffer,2
	CPI  R30,LOW(0x1)
	BRNE _0x1E
; 0000 015F 					   {
; 0000 0160 						rx_temp = 1; //     UART
	SBI  0x1E,5
; 0000 0161 						tx_a [1] = 2; //:     UART
	LDI  R30,LOW(2)
	__PUTB1MN _tx_a,1
; 0000 0162 						tx_a [2] = 1; //    UART
	LDI  R30,LOW(1)
	__PUTB1MN _tx_a,2
; 0000 0163 					    };
_0x1E:
; 0000 0164 
; 0000 0165 					if (rx_buffer [2] == 0)
	__GETB1MN _rx_buffer,2
	CPI  R30,0
	BRNE _0x21
; 0000 0166 					   {
; 0000 0167 						rx_temp = 0; //     UART
	CBI  0x1E,5
; 0000 0168 						tx_a [1] = 2; //:     UART
	LDI  R30,LOW(2)
	__PUTB1MN _tx_a,1
; 0000 0169 						tx_a [2] = 0; //     UART
	LDI  R30,LOW(0)
	__PUTB1MN _tx_a,2
; 0000 016A 						};
_0x21:
; 0000 016B 			break;
	RJMP _0x1B
; 0000 016C 			// rtc
; 0000 016D 			case 3:  s_w = rx_buffer [2] & 0b00111111; // 
_0x1D:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x1B
	__GETB1MN _rx_buffer,2
	ANDI R30,LOW(0x3F)
	MOV  R16,R30
; 0000 016E 
; 0000 016F 					 m_w = ((rx_buffer [2] >> 6) & 0b00000011) | ((rx_buffer [3] << 2) & 0b00111100); // 
	__GETB1MN _rx_buffer,2
	SWAP R30
	ANDI R30,0xF
	LSR  R30
	LSR  R30
	ANDI R30,LOW(0x3)
	MOV  R26,R30
	__GETB1MN _rx_buffer,3
	LSL  R30
	LSL  R30
	ANDI R30,LOW(0x3C)
	OR   R30,R26
	MOV  R19,R30
; 0000 0170 
; 0000 0171 					 h_w = ((rx_buffer [3] >> 4) & 0b00001111) | ((rx_buffer [4] << 4) & 0b00010000); // 
	__GETB1MN _rx_buffer,3
	SWAP R30
	ANDI R30,LOW(0xF)
	MOV  R26,R30
	__GETB1MN _rx_buffer,4
	SWAP R30
	ANDI R30,LOW(0x10)
	OR   R30,R26
	MOV  R18,R30
; 0000 0172 
; 0000 0173 					 rtc_set_time (h_w, m_w, s_w); // 
	ST   -Y,R18
	ST   -Y,R19
	ST   -Y,R16
	CALL _rtc_set_time
; 0000 0174 
; 0000 0175 					 rtc_get_time(&h, &m, &s); //read time from the DS1307 RTC
	CALL SUBOPT_0x3
; 0000 0176 
; 0000 0177 					 year_w = rx_buffer [4] >> 1; // 
	__GETB1MN _rx_buffer,4
	LSR  R30
	STD  Y+6,R30
; 0000 0178 
; 0000 0179 					 month_w = rx_buffer [5] & 0b00001111; // 
	__GETB1MN _rx_buffer,5
	ANDI R30,LOW(0xF)
	MOV  R20,R30
; 0000 017A 
; 0000 017B 					 date_w = ((rx_buffer [5] >> 4) & 0b00001111) | ((rx_buffer [6] << 4) & 0b00010000); // 
	__GETB1MN _rx_buffer,5
	SWAP R30
	ANDI R30,LOW(0xF)
	MOV  R26,R30
	__GETB1MN _rx_buffer,6
	SWAP R30
	ANDI R30,LOW(0x10)
	OR   R30,R26
	MOV  R21,R30
; 0000 017C 
; 0000 017D 					 rtc_set_date (date_w, month_w, year_w); // 
	ST   -Y,R21
	ST   -Y,R20
	LDD  R30,Y+8
	ST   -Y,R30
	CALL _rtc_set_date
; 0000 017E 
; 0000 017F 					 rtc_get_date (&date, &month, &year); // 
	CALL SUBOPT_0x7
; 0000 0180 
; 0000 0181 					 tx_a [1] = 4; // , 4 - 
	LDI  R30,LOW(4)
	__PUTB1MN _tx_a,1
; 0000 0182 
; 0000 0183 					 if ((s_w == s) & (m_w == m) & (h_w == h) & (year_w == year) & (month_w == month) & (date_w == date)) //    
	MOV  R30,R6
	MOV  R26,R16
	CALL __EQB12
	MOV  R0,R30
	MOV  R30,R7
	MOV  R26,R19
	CALL __EQB12
	AND  R0,R30
	MOV  R30,R4
	MOV  R26,R18
	CALL __EQB12
	AND  R0,R30
	MOV  R30,R11
	LDD  R26,Y+6
	CALL __EQB12
	AND  R0,R30
	MOV  R30,R8
	MOV  R26,R20
	CALL __EQB12
	AND  R0,R30
	MOV  R30,R9
	MOV  R26,R21
	CALL __EQB12
	AND  R30,R0
	BREQ _0x25
; 0000 0184 					    {
; 0000 0185 					     tx_a [2] = 1; //rtc 
	LDI  R30,LOW(1)
	RJMP _0xD6
; 0000 0186 						 }
; 0000 0187 					 else {
_0x25:
; 0000 0188 					       tx_a [2] = 0; //rtc 
	LDI  R30,LOW(0)
_0xD6:
	__PUTB1MN _tx_a,2
; 0000 0189 						   };
; 0000 018A 			break;
; 0000 018B 			};
_0x1B:
; 0000 018C 
; 0000 018D 	tx_a [7] = w1_dow_crc8(tx_a, 7); // CRC
	LDI  R30,LOW(_tx_a)
	LDI  R31,HIGH(_tx_a)
	CALL SUBOPT_0x10
	__PUTB1MN _tx_a,7
; 0000 018E 
; 0000 018F 	for (j = 0; j < 8; j++)
	LDI  R17,LOW(0)
_0x28:
	CPI  R17,8
	BRSH _0x29
; 0000 0190 		{
; 0000 0191 		 putchar (tx_a [j]); //  
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_tx_a)
	SBCI R31,HIGH(-_tx_a)
	LD   R30,Z
	ST   -Y,R30
	CALL _putchar
; 0000 0192 		 };
	SUBI R17,-1
	RJMP _0x28
_0x29:
; 0000 0193 
; 0000 0194 	rx_wr_index = 0; // 
	CLR  R5
; 0000 0195 
; 0000 0196 	rxerror_cl = 1; //   
	SBI  0x1E,0
; 0000 0197 	}
; 0000 0198 else {
	RJMP _0x2C
_0x18:
; 0000 0199 	  rx_wr_index++; //  
	INC  R5
; 0000 019A 
; 0000 019B 	  if (rx_wr_index == 8) // ,       
	LDI  R30,LOW(8)
	CP   R30,R5
	BRNE _0x2D
; 0000 019C 		 {
; 0000 019D 		  rx_wr_index = 0; //  
	CLR  R5
; 0000 019E 
; 0000 019F 		  rxerror = 1; //  
	SBI  0x1E,1
; 0000 01A0 		  rxerror_cl = 0; //   
	CBI  0x1E,0
; 0000 01A1 
; 0000 01A2 		  if (!(rx_buffer [7] == w1_dow_crc8(rx_buffer, 7))) //   CRC
	CALL SUBOPT_0xF
	CP   R30,R26
	BREQ _0x32
; 0000 01A3 		     {
; 0000 01A4 			  rx_error_crc = 1; //  crc
	SBI  0x1E,2
; 0000 01A5 			  };
_0x32:
; 0000 01A6 
; 0000 01A7 		  if (!(rx_buffer [0] == 0xa1)) //   
	LDS  R26,_rx_buffer
	CPI  R26,LOW(0xA1)
	BREQ _0x35
; 0000 01A8 		     {
; 0000 01A9 			  rx_error_head = 1; //  
	SBI  0x1E,3
; 0000 01AA 			  };
_0x35:
; 0000 01AB 		  };
_0x2D:
; 0000 01AC 	  };
_0x2C:
; 0000 01AD } //***********************************************************************************************************************************************
	CALL __LOADLOCR6
	ADIW R28,7
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R15,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;
;// Timer 0 overflow interrupt service routine******************************
;interrupt [TIM0_OVF] void __timer0_ovf_isr(void) //    -    < 8- 
; 0000 01B1 {
___timer0_ovf_isr:
	ST   -Y,R30
	IN   R30,SREG
	ST   -Y,R30
; 0000 01B2  rx_wr_index = 0; //  
	CLR  R5
; 0000 01B3 
; 0000 01B4  TCCR0B = 0; // 
	LDI  R30,LOW(0)
	OUT  0x25,R30
; 0000 01B5  TCNT0 = 0; // 
	OUT  0x26,R30
; 0000 01B6 } //*****************************************************************
	LD   R30,Y+
	OUT  SREG,R30
	LD   R30,Y+
	RETI
;
;void main ()
; 0000 01B9 {
_main:
; 0000 01BA char i, j, k; // 
; 0000 01BB char error_delay_counter = 0;
; 0000 01BC char data [9]; //  SRAM DS18B20
; 0000 01BD unsigned long int temp, temp2; // 
; 0000 01BE 
; 0000 01BF bit rtc_r = 1; //    rtc
; 0000 01C0 
; 0000 01C1 //--------------------------------------------
; 0000 01C2 char dac_counter = 0;
; 0000 01C3 bit dac_counter_course = 0;
; 0000 01C4 char adc_data [4];
; 0000 01C5 //--------------------------------------------
; 0000 01C6 
; 0000 01C7 __watchdog_init (); //    0,52 
	SBIW R28,21
;	i -> R17
;	j -> R16
;	k -> R19
;	error_delay_counter -> R18
;	data -> Y+12
;	temp -> Y+8
;	temp2 -> Y+4
;	rtc_r -> R15.0
;	dac_counter -> R21
;	dac_counter_course -> R15.1
;	adc_data -> Y+0
	LDI  R30,LOW(1)
	MOV  R15,R30
	LDI  R18,0
	LDI  R21,0
	RCALL ___watchdog_init
; 0000 01C8 
; 0000 01C9 __io_init (); // 
	RCALL ___io_init
; 0000 01CA 
; 0000 01CB lcd_init (); // LCD
	CALL _lcd_init
; 0000 01CC 
; 0000 01CD i2c_init (); // initialize the I2C bus
	CALL _i2c_init
; 0000 01CE 
; 0000 01CF rtc_init (0, 1, 0); //initialize the DS1307 RTC
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _rtc_init
; 0000 01D0 
; 0000 01D1 //
; 0000 01D2 rtc_set_time (1, 2, 3);
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _rtc_set_time
; 0000 01D3 
; 0000 01D4 rtc_set_date (4, 5, 6);
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _rtc_set_date
; 0000 01D5 //
; 0000 01D6 
; 0000 01D7 __usart_init (); // USART Baud Rate: 57600
	RCALL ___usart_init
; 0000 01D8 
; 0000 01D9 __interrupt_init (); //  
	RCALL ___interrupt_init
; 0000 01DA 
; 0000 01DB __rtc_init_gotoxy (32, 0); //   rtc
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL ___rtc_init_gotoxy
; 0000 01DC 
; 0000 01DD lcd_gotoxy (36, 3); //  
	LDI  R30,LOW(36)
	CALL SUBOPT_0x11
; 0000 01DE sprintf (lcd_buffer, "v%u.%u", version/10, version%10);
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,24
	ST   -Y,R31
	ST   -Y,R30
	__GETD1N 0x0
	CALL __PUTPARD1
	__GETD1N 0x1
	CALL SUBOPT_0x13
; 0000 01DF lcd_puts (lcd_buffer);
	CALL SUBOPT_0x14
; 0000 01E0 
; 0000 01E1 //-------------------------------------
; 0000 01E2 lcd_gotoxy (30, 3);
	LDI  R30,LOW(30)
	CALL SUBOPT_0x11
; 0000 01E3 lcd_putsf ("-DAC");
	__POINTW1FN _0x0,31
	CALL SUBOPT_0x1
; 0000 01E4 
; 0000 01E5 lcd_gotoxy (20, 0);
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_gotoxy
; 0000 01E6 lcd_putsf ("-ADC0");
	__POINTW1FN _0x0,36
	CALL SUBOPT_0x1
; 0000 01E7 
; 0000 01E8 lcd_gotoxy (20, 1);
	LDI  R30,LOW(20)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
; 0000 01E9 lcd_putsf ("-ADC1");
	__POINTW1FN _0x0,42
	CALL SUBOPT_0x1
; 0000 01EA 
; 0000 01EB lcd_gotoxy (20, 2);
	LDI  R30,LOW(20)
	CALL SUBOPT_0x15
; 0000 01EC lcd_putsf ("-ADC2");
	__POINTW1FN _0x0,48
	CALL SUBOPT_0x1
; 0000 01ED 
; 0000 01EE lcd_gotoxy (20, 3);
	LDI  R30,LOW(20)
	CALL SUBOPT_0x11
; 0000 01EF lcd_putsf ("-ADC3");
	__POINTW1FN _0x0,54
	CALL SUBOPT_0x1
; 0000 01F0 //-------------------------------------
; 0000 01F1 
; 0000 01F2 tx_data [0] = 0xa2;  // 
	LDI  R30,LOW(162)
	STS  _tx_data,R30
; 0000 01F3 tx_a [0] = 0xa2;  // 
	STS  _tx_a,R30
; 0000 01F4 tx_data [1] = 0x03; //:  , , 
	LDI  R30,LOW(3)
	__PUTB1MN _tx_data,1
; 0000 01F5 
; 0000 01F6 GREEN_LED = 0; // 
	CBI  0x5,7
; 0000 01F7 #asm ("wdr"); //  
	wdr
; 0000 01F8 devices = w1_search (0xf0, rom_code); //   
	LDI  R30,LOW(240)
	ST   -Y,R30
	LDI  R30,LOW(_rom_code)
	LDI  R31,HIGH(_rom_code)
	ST   -Y,R31
	ST   -Y,R30
	CALL _w1_search
	MOV  R10,R30
; 0000 01F9 GREEN_LED = 1;
	SBI  0x5,7
; 0000 01FA 
; 0000 01FB #asm ("sei"); //  
	sei
; 0000 01FC 
; 0000 01FD if (devices) //   
	TST  R10
	BRNE PC+3
	JMP _0x3C
; 0000 01FE    {
; 0000 01FF     for (k = 0; k < devices; k++) // crc rom 
	LDI  R19,LOW(0)
_0x3E:
	CP   R19,R10
	BRLO PC+3
	JMP _0x3F
; 0000 0200 	{
; 0000 0201 	 if (!(w1_dow_crc8(rom_code [k], 7) == rom_code [k][7])) //   CRC   "t#- CRC_R!"
	CALL SUBOPT_0x16
	CALL SUBOPT_0x10
	MOV  R20,R30
	LDI  R26,LOW(9)
	MUL  R19,R26
	MOVW R30,R0
	__ADDW1MN _rom_code,7
	LD   R30,Z
	CP   R30,R20
	BREQ _0x40
; 0000 0202 	    {
; 0000 0203 	     rom_error |= 1 << k; //   
	CALL SUBOPT_0x17
	OR   R12,R30
; 0000 0204 
; 0000 0205 		 sprintf (lcd_buffer, "t%u- CRC_R!", k + 1);
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,60
	RJMP _0xD7
; 0000 0206 		 lcd_gotoxy (0, k);
; 0000 0207 		 __lcd_ruscoder_puts (lcd_buffer);
; 0000 0208          }
; 0000 0209 	 else { //   crc
_0x40:
; 0000 020A 	       switch (rom_code [k][0]) //  
	CALL SUBOPT_0x16
	LD   R30,Z
; 0000 020B 		          {
; 0000 020C 				   case 0x10: sensor_type |= (1 << k); // DS18S20 //0x10!!!!!
	CPI  R30,LOW(0x10)
	BRNE _0x45
	CALL SUBOPT_0x17
	LDS  R26,_sensor_type
	OR   R30,R26
	STS  _sensor_type,R30
; 0000 020D 
; 0000 020E 				   break;
	RJMP _0x44
; 0000 020F 
; 0000 0210 				   case 0x28: sensor_type &= (~(1 << k)); // DS18B20
_0x45:
	CPI  R30,LOW(0x28)
	BRNE _0x47
	CALL SUBOPT_0x17
	COM  R30
	LDS  R26,_sensor_type
	AND  R30,R26
	STS  _sensor_type,R30
; 0000 0211 				   break;
	RJMP _0x44
; 0000 0212 
; 0000 0213 				   default: no_t_sensor |= (1 << k); //,   
_0x47:
	CALL SUBOPT_0x17
	LDS  R26,_no_t_sensor
	OR   R30,R26
	STS  _no_t_sensor,R30
; 0000 0214 
; 0000 0215 							sprintf (lcd_buffer, "t%u-  t-!", k + 1);
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,78
_0xD7:
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x18
; 0000 0216 		                    lcd_gotoxy (0, k);
	CALL SUBOPT_0x19
; 0000 0217 		                    __lcd_ruscoder_puts (lcd_buffer);
	RCALL ___lcd_ruscoder_puts
; 0000 0218 				   }
_0x44:
; 0000 0219 		   };
; 0000 021A 	 };
	SUBI R19,-1
	RJMP _0x3E
_0x3F:
; 0000 021B     n_crc_error = __byte_length (rom_error); //     crc rom 
	ST   -Y,R12
	RCALL ___byte_length
	MOV  R13,R30
; 0000 021C 
; 0000 021D 	n_no_t_sensor = __byte_length (no_t_sensor); //   t-
	LDS  R30,_no_t_sensor
	ST   -Y,R30
	RCALL ___byte_length
	STS  _n_no_t_sensor,R30
; 0000 021E 	}
; 0000 021F else { // ,   "1-Wire  !"
	RJMP _0x48
_0x3C:
; 0000 0220       wire1_no = 1;
	SBI  0x1E,4
; 0000 0221 
; 0000 0222 	  lcd_gotoxy (0, 0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	CALL _lcd_gotoxy
; 0000 0223 	  lcd_putsf ("1-Wire");
	__POINTW1FN _0x0,96
	CALL SUBOPT_0x1
; 0000 0224 
; 0000 0225 	  sprintf (lcd_buffer, "");
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,103
	CALL SUBOPT_0x1A
; 0000 0226 	  lcd_gotoxy (2, 1);
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
; 0000 0227 	  __lcd_ruscoder_puts (lcd_buffer);
	CALL SUBOPT_0x12
	RCALL ___lcd_ruscoder_puts
; 0000 0228 
; 0000 0229 	  sprintf (lcd_buffer, "!");
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,117
	CALL SUBOPT_0x1A
; 0000 022A 	  lcd_gotoxy (11, 2);
	LDI  R30,LOW(11)
	CALL SUBOPT_0x15
; 0000 022B 	  __lcd_ruscoder_puts (lcd_buffer);
	CALL SUBOPT_0x12
	RCALL ___lcd_ruscoder_puts
; 0000 022C 	  };
_0x48:
; 0000 022D 
; 0000 022E i = 0;
	LDI  R17,LOW(0)
; 0000 022F 
; 0000 0230 while (1) // 
_0x4B:
; 0000 0231       {
; 0000 0232 	   if (__byte_length (no_sensor) == (devices - n_no_t_sensor)); //  ,      -----------------------------
	CALL SUBOPT_0x1B
	CP   R30,R0
	BREQ _0x4F
; 0000 0233 	   else
; 0000 0234 		  { //  
; 0000 0235            w1_init(); //
	CALL _w1_init
; 0000 0236            w1_write (0xcc); //SKIP ROM [CCh]    
	LDI  R30,LOW(204)
	ST   -Y,R30
	CALL _w1_write
; 0000 0237 
; 0000 0238            w1_write (0x44); //CONVERT T [44h]   
	LDI  R30,LOW(68)
	ST   -Y,R30
	CALL _w1_write
; 0000 0239 
; 0000 023A            while (!w1_read ()) //  
_0x50:
	CALL _w1_read
	CPI  R30,0
	BRNE _0x52
; 0000 023B               {
; 0000 023C                delay_ms (70);
	LDI  R30,LOW(70)
	LDI  R31,HIGH(70)
	CALL SUBOPT_0xC
; 0000 023D 
; 0000 023E 	           /*if ((!NEW_TIME) & rtc_r) //  ,      ----
; 0000 023F 	              {
; 0000 0240 		           __rtc_lcd_gotoxy (32, 0); //   
; 0000 0241 
; 0000 0242 		           rtc_r = 0;
; 0000 0243 		           };
; 0000 0244 
; 0000 0245 		       if (!NEW_TIME) //       
; 0000 0246 		          {
; 0000 0247 		           rtc_r = 1;
; 0000 0248 			       };*/ //------------------------------------------------------------------------------------------------------------------
; 0000 0249 	            };
	RJMP _0x50
_0x52:
; 0000 024A 		   }; //-------------------------------------------------------------------------------------------------------------------------------------------------
_0x4F:
; 0000 024B 
; 0000 024C 	   if (error_delay_counter >= i) //        
	CP   R18,R17
	BRSH PC+3
	JMP _0x53
; 0000 024D 	   {
; 0000 024E 	   GREEN_LED = 0; // 
	CBI  0x5,7
; 0000 024F 
; 0000 0250 	   for (k = 0; k < devices; k++) //   =====================================================
	LDI  R19,LOW(0)
_0x57:
	CP   R19,R10
	BRLO PC+3
	JMP _0x58
; 0000 0251 	       {
; 0000 0252 			if ((rom_error & (1 << k)) | (no_t_sensor & (1 << k))); //  CRC ROM     
	CALL SUBOPT_0x17
	MOV  R26,R30
	AND  R30,R12
	MOV  R1,R30
	MOV  R30,R26
	LDS  R26,_no_t_sensor
	AND  R30,R26
	OR   R30,R1
	BREQ _0x59
; 0000 0253 		    else //  
	RJMP _0x5A
_0x59:
; 0000 0254 			{
; 0000 0255 	        w1_init(); //
	CALL _w1_init
; 0000 0256 		    w1_write (0x55); //MATCH ROM [55h]   k- 
	LDI  R30,LOW(85)
	ST   -Y,R30
	CALL _w1_write
; 0000 0257 
; 0000 0258             for (j = 0; j < 8; j++) // rom  k- 
	LDI  R16,LOW(0)
_0x5C:
	CPI  R16,8
	BRSH _0x5D
; 0000 0259                 {
; 0000 025A 	             w1_write (rom_code [k][j]);
	CALL SUBOPT_0x16
	MOVW R26,R30
	CLR  R30
	ADD  R26,R16
	ADC  R27,R30
	LD   R30,X
	ST   -Y,R30
	CALL _w1_write
; 0000 025B 	             };
	SUBI R16,-1
	RJMP _0x5C
_0x5D:
; 0000 025C 
; 0000 025D 	        w1_write (0xbe); //READ SCRATCHPAD [BEh]   
	LDI  R30,LOW(190)
	ST   -Y,R30
	CALL _w1_write
; 0000 025E 
; 0000 025F             for (j = 0; j < 9; j++) // SCRATCHPAD
	LDI  R16,LOW(0)
_0x5F:
	CPI  R16,9
	BRSH _0x60
; 0000 0260 		        {
; 0000 0261 		  	     data [j] = w1_read (); // 
	CALL SUBOPT_0x1C
	MOVW R26,R28
	ADIW R26,12
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	CALL _w1_read
	POP  R26
	POP  R27
	ST   X,R30
; 0000 0262 			    };
	SUBI R16,-1
	RJMP _0x5F
_0x60:
; 0000 0263 
; 0000 0264 
; 0000 0265 
; 0000 0266 		    // --------------------------------------------------------------------------------------------------------------
; 0000 0267 		    if ((data [6] == 255) & (data [7] == 255)) //  ,  "t#-  !"
	LDD  R26,Y+18
	LDI  R30,LOW(255)
	CALL __EQB12
	MOV  R0,R30
	LDD  R26,Y+19
	LDI  R30,LOW(255)
	CALL __EQB12
	AND  R30,R0
	BREQ _0x61
; 0000 0268 		       {
; 0000 0269 		        no_sensor |= 1 << k; //   
	CALL SUBOPT_0x17
	LDS  R26,_no_sensor
	OR   R30,R26
	STS  _no_sensor,R30
; 0000 026A 
; 0000 026B 		        sprintf (lcd_buffer, "t%u-  !", k + 1);
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,122
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x18
; 0000 026C 		        lcd_gotoxy (0, k);
	CALL SUBOPT_0x19
; 0000 026D 		        __lcd_ruscoder_puts (lcd_buffer);
	RCALL ___lcd_ruscoder_puts
; 0000 026E 		        }
; 0000 026F 		    else { // CRC
	RJMP _0x62
_0x61:
; 0000 0270 		          i = w1_dow_crc8(data, 8); // CRC
	MOVW R30,R28
	ADIW R30,12
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	CALL _w1_dow_crc8
	MOV  R17,R30
; 0000 0271 
; 0000 0272 		          if (!(i == data [8])) //   CRC   "t#-  CRC! "
	LDD  R30,Y+20
	CP   R30,R17
	BREQ _0x63
; 0000 0273                      {
; 0000 0274                       sensor_crc_error |= 1 << k; //   
	CALL SUBOPT_0x17
	LDS  R26,_sensor_crc_error
	OR   R30,R26
	STS  _sensor_crc_error,R30
; 0000 0275 
; 0000 0276 			          sprintf (lcd_buffer, "t%u-  CRC! ", k + 1);
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,140
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x18
; 0000 0277 			          lcd_gotoxy (0, k);
	CALL SUBOPT_0x19
; 0000 0278 			          __lcd_ruscoder_puts (lcd_buffer);
	RCALL ___lcd_ruscoder_puts
; 0000 0279 			          }
; 0000 027A 		          else { // crc ,   :)
	RJMP _0x64
_0x63:
; 0000 027B 						if (sensor_crc_error & (1 << k)) // crc ,   
	CALL SUBOPT_0x17
	LDS  R26,_sensor_crc_error
	AND  R30,R26
	BREQ _0x65
; 0000 027C 						   {
; 0000 027D 						    sensor_crc_error &= 0 << k;
	LDS  R30,_sensor_crc_error
	ANDI R30,LOW(0x0)
	STS  _sensor_crc_error,R30
; 0000 027E 							};
_0x65:
; 0000 027F 
; 0000 0280 						if (no_sensor & (1 << k)) //  ,   
	CALL SUBOPT_0x17
	LDS  R26,_no_sensor
	AND  R30,R26
	BREQ _0x66
; 0000 0281 						   {
; 0000 0282 						    no_sensor &= 0 << k;
	LDS  R30,_no_sensor
	ANDI R30,LOW(0x0)
	STS  _no_sensor,R30
; 0000 0283 							};
_0x66:
; 0000 0284                         //  --------------------------------------------------------
; 0000 0285 						if (sensor_type & (1 << k)) //  
	CALL SUBOPT_0x17
	LDS  R26,_sensor_type
	AND  R30,R26
	BREQ _0x67
; 0000 0286 						{ //DS18S20
; 0000 0287 						 tx_data [2] = k; //  k- 
	__PUTBMRN _tx_data,2,19
; 0000 0288                          tx_data [4] = 1; //   DS18S20
	LDI  R30,LOW(1)
	__PUTB1MN _tx_data,4
; 0000 0289 
; 0000 028A 						 if (data [1] == 0xff) //  
	LDD  R26,Y+13
	CPI  R26,LOW(0xFF)
	BRNE _0x68
; 0000 028B 						    {
; 0000 028C 							 tx_data [2] = tx_data [2] | 0b00010000; //  
	CALL SUBOPT_0x1D
; 0000 028D 
; 0000 028E 							 data [0] = ~ data [0];
; 0000 028F 
; 0000 0290 							 temp = data [0] >> 1;
	CALL SUBOPT_0x1E
; 0000 0291 
; 0000 0292 						     temp *= 10000;
; 0000 0293 
; 0000 0294 						     temp -= 7500;
	__SUBD1N 7500
	CALL SUBOPT_0x1F
; 0000 0295 
; 0000 0296 						     temp2 = data [6];
; 0000 0297 
; 0000 0298 						     temp2 *= 10000;
; 0000 0299 
; 0000 029A 						     temp2 /= data [7];
; 0000 029B 
; 0000 029C 						     temp += temp2;
	__GETD1S 4
	CALL SUBOPT_0x20
	CALL __ADDD12
	RJMP _0xD8
; 0000 029D 							 //temp /= 2;
; 0000 029E 							 }
; 0000 029F 					     else
_0x68:
; 0000 02A0 						 {
; 0000 02A1 						 temp = data [0] >> 1;
	CALL SUBOPT_0x1E
; 0000 02A2 
; 0000 02A3 						 temp *= 10000;
; 0000 02A4 
; 0000 02A5 						 temp += 7500;
	__ADDD1N 7500
	CALL SUBOPT_0x1F
; 0000 02A6 
; 0000 02A7 						 temp2 = data [6];
; 0000 02A8 
; 0000 02A9 						 temp2 *= 10000;
; 0000 02AA 
; 0000 02AB 						 temp2 /= data [7];
; 0000 02AC 
; 0000 02AD 						 temp -= temp2;
	__GETD2S 4
	CALL SUBOPT_0x21
	CALL __SUBD12
_0xD8:
	__PUTD1S 8
; 0000 02AE 						 };
; 0000 02AF 
; 0000 02B0 						 if (data [1] == 0xff) //  
	LDD  R26,Y+13
	CPI  R26,LOW(0xFF)
	BRNE _0x6A
; 0000 02B1 				            {
; 0000 02B2 				             i = '-'; //  "-"
	LDI  R17,LOW(45)
; 0000 02B3 				             }
; 0000 02B4                          else {
	RJMP _0x6B
_0x6A:
; 0000 02B5 				               i = '+'; //  "+"
	LDI  R17,LOW(43)
; 0000 02B6 					           };
_0x6B:
; 0000 02B7 
; 0000 02B8 						 j = '_'; //   DS18S20
	LDI  R16,LOW(95)
; 0000 02B9 
; 0000 02BA 						 lcd_gotoxy (15, k); // 
	CALL SUBOPT_0x22
; 0000 02BB 						 lcd_putsf (" ");
	CALL SUBOPT_0x23
; 0000 02BC 						 }
; 0000 02BD 						else
	RJMP _0x6C
_0x67:
; 0000 02BE 						{ //DS18B20
; 0000 02BF 						tx_data [4] = 0; //   DS18B20
	LDI  R30,LOW(0)
	__PUTB1MN _tx_data,4
; 0000 02C0 
; 0000 02C1 						i = (data [1] & 0b11111000) >> 3; //  
	LDD  R30,Y+13
	ANDI R30,LOW(0xF8)
	LSR  R30
	LSR  R30
	LSR  R30
	MOV  R17,R30
; 0000 02C2 
; 0000 02C3 			            tx_data [2] = k; //  k- 
	__PUTBMRN _tx_data,2,19
; 0000 02C4 
; 0000 02C5 			            if (i == 31) //  
	CPI  R17,31
	BRNE _0x6D
; 0000 02C6 				           {
; 0000 02C7 				            tx_data [2] = tx_data [2] | 0b00010000; //  
	CALL SUBOPT_0x1D
; 0000 02C8 
; 0000 02C9 				            data [0] = ~ data [0];
; 0000 02CA 				            data [1] = ~ data [1];
	LDD  R30,Y+13
	COM  R30
	STD  Y+13,R30
; 0000 02CB 				            };
_0x6D:
; 0000 02CC 
; 0000 02CD 		                temp = data [1];
	LDD  R30,Y+13
	CLR  R31
	CLR  R22
	CLR  R23
	CALL SUBOPT_0x24
; 0000 02CE 
; 0000 02CF 		                temp &= 0b00000111; //       3   
	CALL SUBOPT_0x21
	__ANDD1N 0x7
	CALL SUBOPT_0x24
; 0000 02D0 
; 0000 02D1 		                temp <<= 8;
	CALL SUBOPT_0x20
	LDI  R30,LOW(8)
	CALL __LSLD12
	CALL SUBOPT_0x24
; 0000 02D2 
; 0000 02D3 		                temp |= data [0]; // 12-  
	LDD  R30,Y+12
	CALL SUBOPT_0x20
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __ORD12
	CALL SUBOPT_0x24
; 0000 02D4 
; 0000 02D5 			            if (i == 31) //  
	CPI  R17,31
	BRNE _0x6E
; 0000 02D6 				           {
; 0000 02D7 				            temp++;
	CALL SUBOPT_0x21
	__SUBD1N -1
	CALL SUBOPT_0x24
; 0000 02D8 				            i = '-'; //  "-"
	LDI  R17,LOW(45)
; 0000 02D9 				            }
; 0000 02DA                         else {
	RJMP _0x6F
_0x6E:
; 0000 02DB 				              i = '+'; //  "+"
	LDI  R17,LOW(43)
; 0000 02DC 					          };
_0x6F:
; 0000 02DD 
; 0000 02DE 						if (temp > temp_buffer [k]) // -------------------------
	CALL SUBOPT_0x25
	CALL __CPD12
	BRSH _0x70
; 0000 02DF 						   {
; 0000 02E0 						    lcd_gotoxy (15, k);
	CALL SUBOPT_0x22
; 0000 02E1 
; 0000 02E2 							if (i == 45) // ""
	CPI  R17,45
	BRNE _0x71
; 0000 02E3 							   {
; 0000 02E4 							    lcd_putsf ("\xda"); //  
	__POINTW1FN _0x0,158
	RJMP _0xD9
; 0000 02E5 							    }
; 0000 02E6 							else {
_0x71:
; 0000 02E7 							      lcd_putsf ("\xd9"); //  
	__POINTW1FN _0x0,160
_0xD9:
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
; 0000 02E8 								  };
; 0000 02E9 						    };
_0x70:
; 0000 02EA 
; 0000 02EB 						if (temp < temp_buffer [k])
	CALL SUBOPT_0x25
	CALL __CPD21
	BRSH _0x73
; 0000 02EC 						   {
; 0000 02ED 			                lcd_gotoxy (15, k);
	CALL SUBOPT_0x22
; 0000 02EE 
; 0000 02EF 							if (i == 45) // ""
	CPI  R17,45
	BRNE _0x74
; 0000 02F0 							   {
; 0000 02F1 							    lcd_putsf ("\xd9"); //  
	__POINTW1FN _0x0,160
	RJMP _0xDA
; 0000 02F2 							    }
; 0000 02F3 							else {
_0x74:
; 0000 02F4 							      lcd_putsf ("\xda"); //  
	__POINTW1FN _0x0,158
_0xDA:
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
; 0000 02F5 								  };
; 0000 02F6 							};
_0x73:
; 0000 02F7 
; 0000 02F8 						if (temp == temp_buffer [k])
	CALL SUBOPT_0x25
	CALL __CPD12
	BRNE _0x76
; 0000 02F9 						   {
; 0000 02FA 			                lcd_gotoxy (15, k);
	CALL SUBOPT_0x22
; 0000 02FB 							lcd_putsf (" "); // 
	CALL SUBOPT_0x23
; 0000 02FC 							};
_0x76:
; 0000 02FD 
; 0000 02FE 						temp_buffer [k] = temp; //     
	MOV  R30,R19
	LDI  R26,LOW(_temp_buffer)
	LDI  R27,HIGH(_temp_buffer)
	LDI  R31,0
	CALL __LSLW2
	ADD  R30,R26
	ADC  R31,R27
	CALL SUBOPT_0x20
	__PUTDZ2 0
; 0000 02FF 
; 0000 0300 		                temp *= 625; //  --------------------------------------------------------
	CALL SUBOPT_0x20
	__GETD1N 0x271
	CALL __MULD12U
	CALL SUBOPT_0x24
; 0000 0301 
; 0000 0302 						j = ' ';
	LDI  R16,LOW(32)
; 0000 0303 						};
_0x6C:
; 0000 0304 
; 0000 0305 						//-----------------------------------------------------------------------------------------------------------------------------------
; 0000 0306                         sprintf (lcd_buffer, "t%u=%c%c%", k + 1, j, i); // 
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,162
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R19
	SUBI R30,-LOW(1)
	CALL SUBOPT_0x26
	MOV  R30,R16
	CALL SUBOPT_0x26
	MOV  R30,R17
	CALL SUBOPT_0x26
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
; 0000 0307                         lcd_gotoxy (0, k); //  
	LDI  R30,LOW(0)
	CALL SUBOPT_0x27
; 0000 0308 		                lcd_puts (lcd_buffer);
	CALL SUBOPT_0x14
; 0000 0309 
; 0000 030A 						i = temp/10000; //      
	CALL SUBOPT_0x20
	CALL SUBOPT_0x28
	CALL __DIVD21U
	MOV  R17,R30
; 0000 030B 
; 0000 030C 						sprintf (lcd_buffer, "%u.%04u  ", i, temp%10000); // 
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,172
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	CALL SUBOPT_0x26
	__GETD2S 16
	CALL SUBOPT_0x28
	CALL __MODD21U
	CALL SUBOPT_0x13
; 0000 030D 						//     ,         
; 0000 030E 						if (i < 10)
	CPI  R17,10
	BRSH _0x77
; 0000 030F 						   {
; 0000 0310 						    j = 7;
	LDI  R16,LOW(7)
; 0000 0311 
; 0000 0312 							lcd_gotoxy (5, k); //  
	LDI  R30,LOW(5)
	CALL SUBOPT_0x27
; 0000 0313 		                    lcd_putsf ("  ");
	__POINTW1FN _0x0,13
	CALL SUBOPT_0x1
; 0000 0314 							};
_0x77:
; 0000 0315 
; 0000 0316 						if (i >= 10)
	CPI  R17,10
	BRLO _0x78
; 0000 0317 						   {
; 0000 0318 						    j = 6;
	LDI  R16,LOW(6)
; 0000 0319 
; 0000 031A 							lcd_gotoxy (5, k); //  
	LDI  R30,LOW(5)
	CALL SUBOPT_0x27
; 0000 031B 		                    lcd_putsf (" ");
	CALL SUBOPT_0x23
; 0000 031C 							};
_0x78:
; 0000 031D 
; 0000 031E 						if (i >= 100)
	CPI  R17,100
	BRLO _0x79
; 0000 031F 						   {
; 0000 0320 						    j = 5;
	LDI  R16,LOW(5)
; 0000 0321 							};
_0x79:
; 0000 0322 
; 0000 0323 						lcd_gotoxy (j, k); //  
	ST   -Y,R16
	ST   -Y,R19
	CALL _lcd_gotoxy
; 0000 0324 		                lcd_puts (lcd_buffer);
	CALL SUBOPT_0x14
; 0000 0325 
; 0000 0326 						lcd_gotoxy (13, k);
	LDI  R30,LOW(13)
	CALL SUBOPT_0x27
; 0000 0327 						lcd_putsf ("\xdfC"); //---------------------------------------------------------------------------------------------------------
	__POINTW1FN _0x0,182
	CALL SUBOPT_0x1
; 0000 0328 
; 0000 0329                         //  USART------------------------------------------------
; 0000 032A 			            if (rx_temp) //   
	SBIS 0x1E,5
	RJMP _0x7A
; 0000 032B 		                   {
; 0000 032C 			                tx_data [2] = tx_data [2] | (data [0] << 5); // 3   
	__GETB2MN _tx_data,2
	LDD  R30,Y+12
	SWAP R30
	ANDI R30,0xF0
	LSL  R30
	OR   R30,R26
	__PUTB1MN _tx_data,2
; 0000 032D 
; 0000 032E 			                tx_data [3] = 0; //  
	LDI  R30,LOW(0)
	__PUTB1MN _tx_data,3
; 0000 032F 
; 0000 0330 			                tx_data [3] = tx_data [3] | (data [0] >> 3); // 5  
	__GETB2MN _tx_data,3
	LDD  R30,Y+12
	LSR  R30
	LSR  R30
	LSR  R30
	OR   R30,R26
	__PUTB1MN _tx_data,3
; 0000 0331 			                tx_data [3] = tx_data [3] | (data [1] << 5); // 3   
	__GETB2MN _tx_data,3
	LDD  R30,Y+13
	SWAP R30
	ANDI R30,0xF0
	LSL  R30
	OR   R30,R26
	__PUTB1MN _tx_data,3
; 0000 0332 
; 0000 0333 			                tx_data [7] = w1_dow_crc8(tx_data, 7); // CRC
	LDI  R30,LOW(_tx_data)
	LDI  R31,HIGH(_tx_data)
	CALL SUBOPT_0x10
	__PUTB1MN _tx_data,7
; 0000 0334 
; 0000 0335 		                    for (i = 0; i < 8; i++) //   USART
	LDI  R17,LOW(0)
_0x7C:
	CPI  R17,8
	BRSH _0x7D
; 0000 0336 		                        {
; 0000 0337 			                     putchar (tx_data [i]);
	MOV  R30,R17
	LDI  R31,0
	SUBI R30,LOW(-_tx_data)
	SBCI R31,HIGH(-_tx_data)
	LD   R30,Z
	ST   -Y,R30
	RCALL _putchar
; 0000 0338 			                     };
	SUBI R17,-1
	RJMP _0x7C
_0x7D:
; 0000 0339                             }; //----------------------------------------------------------
_0x7A:
; 0000 033A 			            }; //-------------------------------------------------------------------------------------------------------
_0x64:
; 0000 033B                  };
_0x62:
; 0000 033C 		    };
_0x5A:
; 0000 033D 			};
	SUBI R19,-1
	RJMP _0x57
_0x58:
; 0000 033E 
; 0000 033F 			GREEN_LED = 1; //  
	SBI  0x5,7
; 0000 0340 		}; //==============================================================================================================
_0x53:
; 0000 0341 
; 0000 0342 	   if ((!NEW_TIME) & rtc_r) //  ,      ---
	LDI  R26,0
	SBIS 0x9,4
	LDI  R26,1
	LDI  R30,0
	SBRC R15,0
	LDI  R30,1
	AND  R30,R26
	BREQ _0x80
; 0000 0343 	      {
; 0000 0344 		   __rtc_lcd_gotoxy (32, 0); //   
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL ___rtc_lcd_gotoxy
; 0000 0345 
; 0000 0346 		   rtc_r = 0;
	CLT
	BLD  R15,0
; 0000 0347 		   };
_0x80:
; 0000 0348 
; 0000 0349 		if (!NEW_TIME) //       
	SBIC 0x9,4
	RJMP _0x81
; 0000 034A 		   {
; 0000 034B 		    rtc_r = 1;
	SET
	BLD  R15,0
; 0000 034C 			}; //---------------------------------------------------------------------------------------------------------------
_0x81:
; 0000 034D 
; 0000 034E 	   // ===============================================================================
; 0000 034F 	   if (((n_crc_error == devices) & (!wire1_no)) | (n_no_t_sensor == devices)) // crc rom      t- 
	MOV  R30,R10
	MOV  R26,R13
	CALL __EQB12
	MOV  R26,R30
	LDI  R30,0
	SBIS 0x1E,4
	LDI  R30,1
	AND  R30,R26
	MOV  R0,R30
	MOV  R30,R10
	LDS  R26,_n_no_t_sensor
	CALL __EQB12
	OR   R30,R0
	BREQ _0x82
; 0000 0350 	      {
; 0000 0351 		   error_delay_counter++;
	SUBI R18,-1
; 0000 0352 		   i = 1;
	LDI  R17,LOW(1)
; 0000 0353 
; 0000 0354 		   if (error_delay_counter > 30)
	CPI  R18,31
	BRLO _0x83
; 0000 0355 		      {
; 0000 0356 		       RED_LED ^= 1;
	CALL SUBOPT_0x29
	BRNE _0x84
	CBI  0x5,6
	RJMP _0x85
_0x84:
	SBI  0x5,6
_0x85:
; 0000 0357 
; 0000 0358 			   error_delay_counter = 0;
	LDI  R18,LOW(0)
; 0000 0359 			   }
; 0000 035A 		   delay_ms (10);
_0x83:
	CALL SUBOPT_0x2A
; 0000 035B 		   }
; 0000 035C        else {
	RJMP _0x86
_0x82:
; 0000 035D 	         i = 0;
	LDI  R17,LOW(0)
; 0000 035E 			 };
_0x86:
; 0000 035F 
; 0000 0360 	   if (rom_error * (!(n_crc_error == devices))) // crc rom    
	MOV  R30,R10
	MOV  R26,R13
	CALL __EQB12
	CALL __LNEGB1
	MUL  R30,R12
	MOVW R30,R0
	CPI  R30,0
	BREQ _0x87
; 0000 0361 	      {
; 0000 0362 		   if (no_sensor | sensor_crc_error); //         "t#-  ", "t#-  CRC  "
	CALL SUBOPT_0x2B
	BRNE _0x89
; 0000 0363 		   else {
; 0000 0364 		         RED_LED ^= 1;
	CALL SUBOPT_0x29
	BRNE _0x8A
	CBI  0x5,6
	RJMP _0x8B
_0x8A:
	SBI  0x5,6
_0x8B:
; 0000 0365 				 };
_0x89:
; 0000 0366            };
_0x87:
; 0000 0367 
; 0000 0368 	   if (no_t_sensor * (!(n_no_t_sensor == devices))) // t-,  
	MOV  R30,R10
	LDS  R26,_n_no_t_sensor
	CALL __EQB12
	CALL __LNEGB1
	LDS  R26,_no_t_sensor
	MUL  R30,R26
	MOVW R30,R0
	CPI  R30,0
	BREQ _0x8C
; 0000 0369 	      {
; 0000 036A 		   if (no_sensor | sensor_crc_error); //         "t#-  ", "t#-  CRC  "
	CALL SUBOPT_0x2B
	BRNE _0x8E
; 0000 036B 		   else {
; 0000 036C 		         RED_LED ^= 1;
	CALL SUBOPT_0x29
	BRNE _0x8F
	CBI  0x5,6
	RJMP _0x90
_0x8F:
	SBI  0x5,6
_0x90:
; 0000 036D 				 };
_0x8E:
; 0000 036E 		   };
_0x8C:
; 0000 036F 
; 0000 0370 	   if (no_sensor | sensor_crc_error) // "t#-  ", "t#-  CRC  "
	CALL SUBOPT_0x2B
	BREQ _0x91
; 0000 0371 	      {
; 0000 0372 		   if ((__byte_length (no_sensor) == (devices - n_no_t_sensor)) | (__byte_length (sensor_crc_error) == (devices - n_no_t_sensor))) //   
	CALL SUBOPT_0x1B
	MOV  R26,R0
	CALL __EQB12
	MOV  R20,R30
	LDS  R30,_sensor_crc_error
	ST   -Y,R30
	RCALL ___byte_length
	MOV  R0,R30
	LDS  R26,_n_no_t_sensor
	MOV  R30,R10
	SUB  R30,R26
	MOV  R26,R0
	CALL __EQB12
	OR   R30,R20
	BREQ _0x92
; 0000 0373 		      {
; 0000 0374 			   error_delay_counter++; //     1-Wire
	SUBI R18,-1
; 0000 0375 
; 0000 0376 			   i = 30; //  1-Wire  0,3
	LDI  R17,LOW(30)
; 0000 0377 
; 0000 0378 			   if (error_delay_counter > 30)
	CPI  R18,31
	BRLO _0x93
; 0000 0379 		          {
; 0000 037A 		           RED_LED ^= 1; // 
	CALL SUBOPT_0x29
	BRNE _0x94
	CBI  0x5,6
	RJMP _0x95
_0x94:
	SBI  0x5,6
_0x95:
; 0000 037B 			       error_delay_counter = 0; //      1-Wire
	LDI  R18,LOW(0)
; 0000 037C 				   };
_0x93:
; 0000 037D 			   delay_ms (10); //        1-Wire
	CALL SUBOPT_0x2A
; 0000 037E 			   }
; 0000 037F 		   else { //    
	RJMP _0x96
_0x92:
; 0000 0380 		         RED_LED ^= 1;
	CALL SUBOPT_0x29
	BRNE _0x97
	CBI  0x5,6
	RJMP _0x98
_0x97:
	SBI  0x5,6
_0x98:
; 0000 0381 				 };
_0x96:
; 0000 0382 		   };
_0x91:
; 0000 0383 
; 0000 0384 	   if (wire1_no) // "1-Wire  !"
	SBIS 0x1E,4
	RJMP _0x99
; 0000 0385 	      {
; 0000 0386 		   error_delay_counter++;
	SUBI R18,-1
; 0000 0387 
; 0000 0388 		   switch (error_delay_counter)
	MOV  R30,R18
; 0000 0389 		          {
; 0000 038A 		           case 50: RED_LED = 0;
	CPI  R30,LOW(0x32)
	BRNE _0x9D
	CBI  0x5,6
; 0000 038B 				   break;
	RJMP _0x9C
; 0000 038C 
; 0000 038D 				   case 60: RED_LED = 1;
_0x9D:
	CPI  R30,LOW(0x3C)
	BRNE _0xA0
	SBI  0x5,6
; 0000 038E 				   break;
	RJMP _0x9C
; 0000 038F 
; 0000 0390 				   case 70: RED_LED = 0;
_0xA0:
	CPI  R30,LOW(0x46)
	BRNE _0xA3
	CBI  0x5,6
; 0000 0391 				   break;
	RJMP _0x9C
; 0000 0392 
; 0000 0393 				   case 80: RED_LED = 1;
_0xA3:
	CPI  R30,LOW(0x50)
	BRNE _0xA6
	SBI  0x5,6
; 0000 0394 				   break;
	RJMP _0x9C
; 0000 0395 
; 0000 0396 				   case 90: RED_LED = 0;
_0xA6:
	CPI  R30,LOW(0x5A)
	BRNE _0xA9
	CBI  0x5,6
; 0000 0397 				   break;
	RJMP _0x9C
; 0000 0398 
; 0000 0399 				   case 100: RED_LED = 1;
_0xA9:
	CPI  R30,LOW(0x64)
	BRNE _0x9C
	SBI  0x5,6
; 0000 039A 				             error_delay_counter = 0;
	LDI  R18,LOW(0)
; 0000 039B 				   break;
; 0000 039C 		           };
_0x9C:
; 0000 039D 
; 0000 039E 		   delay_ms (10); //  
	CALL SUBOPT_0x2A
; 0000 039F 		   };
_0x99:
; 0000 03A0 
; 0000 03A1 	   if ( no_sensor | sensor_crc_error | rom_error | wire1_no | i | no_t_sensor);//  ,    
	CALL SUBOPT_0x2B
	OR   R30,R12
	MOV  R26,R30
	LDI  R30,0
	SBIC 0x1E,4
	LDI  R30,1
	OR   R30,R26
	OR   R30,R17
	LDS  R26,_no_t_sensor
	OR   R30,R26
	BRNE _0xB0
; 0000 03A2        else {
; 0000 03A3              RED_LED = 1;
	SBI  0x5,6
; 0000 03A4 		     i = 0; //   1-Wire
	LDI  R17,LOW(0)
; 0000 03A5 			 };
_0xB0:
; 0000 03A6 
; 0000 03A7 	   if (rxerror_cl) //   ,   --------------------------
	SBIS 0x1E,0
	RJMP _0xB3
; 0000 03A8 	      {
; 0000 03A9            rxerror_cl = 0;
	CBI  0x1E,0
; 0000 03AA 
; 0000 03AB 	       lcd_gotoxy (21, 2);
	LDI  R30,LOW(21)
	CALL SUBOPT_0x15
; 0000 03AC 		   lcd_putsf ("                   "); //  
	__POINTW1FN _0x0,185
	CALL SUBOPT_0x1
; 0000 03AD 	       };
_0xB3:
; 0000 03AE 
; 0000 03AF 	   if (rxerror) //  
	SBIS 0x1E,1
	RJMP _0xB6
; 0000 03B0 	      {
; 0000 03B1 		   rxerror = 0;
	CBI  0x1E,1
; 0000 03B2 
; 0000 03B3 		   sprintf (lcd_buffer, " RX "); //  
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,205
	CALL SUBOPT_0x1A
; 0000 03B4            lcd_gotoxy (21, 2);
	LDI  R30,LOW(21)
	CALL SUBOPT_0x15
; 0000 03B5 		   __lcd_ruscoder_puts (lcd_buffer);
	CALL SUBOPT_0x12
	RCALL ___lcd_ruscoder_puts
; 0000 03B6 	       };
_0xB6:
; 0000 03B7 
; 0000 03B8 	   if (rx_error_crc & rx_error_head) //    crc
	LDI  R26,0
	SBIC 0x1E,2
	LDI  R26,1
	LDI  R30,0
	SBIC 0x1E,3
	LDI  R30,1
	AND  R30,R26
	BREQ _0xB9
; 0000 03B9 	      {
; 0000 03BA 		   rx_error_crc = 0;
	CBI  0x1E,2
; 0000 03BB 		   rx_error_head = 0;
	CBI  0x1E,3
; 0000 03BC 
; 0000 03BD 		   sprintf (lcd_buffer, "-,CRC");
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,216
	RJMP _0xDB
; 0000 03BE 		   lcd_gotoxy (31, 2);
; 0000 03BF 		   __lcd_ruscoder_puts (lcd_buffer);
; 0000 03C0 		   }
; 0000 03C1 	   else {
_0xB9:
; 0000 03C2 	         if (rx_error_crc)
	SBIS 0x1E,2
	RJMP _0xBF
; 0000 03C3 	            {
; 0000 03C4 		         rx_error_crc = 0;
	CBI  0x1E,2
; 0000 03C5 
; 0000 03C6 		         lcd_gotoxy (31, 2);
	LDI  R30,LOW(31)
	CALL SUBOPT_0x15
; 0000 03C7 		         lcd_putsf ("CRC      "); // "CRC"
	__POINTW1FN _0x0,226
	CALL SUBOPT_0x1
; 0000 03C8 		         };
_0xBF:
; 0000 03C9 
; 0000 03CA 	         if (rx_error_head)
	SBIS 0x1E,3
	RJMP _0xC2
; 0000 03CB 	            {
; 0000 03CC 		         rx_error_head = 0;
	CBI  0x1E,3
; 0000 03CD 
; 0000 03CE 		         sprintf (lcd_buffer, ""); // ""
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,236
_0xDB:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _sprintf
	ADIW R28,4
; 0000 03CF 		         lcd_gotoxy (31, 2);
	LDI  R30,LOW(31)
	CALL SUBOPT_0x15
; 0000 03D0 		         __lcd_ruscoder_puts (lcd_buffer);
	CALL SUBOPT_0x12
	RCALL ___lcd_ruscoder_puts
; 0000 03D1 		         };
_0xC2:
; 0000 03D2              }; //===================================================================================
; 0000 03D3 
; 0000 03D4 		// I2C----------------------------------------
; 0000 03D5 		//  DAC
; 0000 03D6 		__dac_write (dac_counter);
	ST   -Y,R21
	RCALL ___dac_write
; 0000 03D7 
; 0000 03D8 		lcd_gotoxy (26, 3); // DAC
	LDI  R30,LOW(26)
	CALL SUBOPT_0x11
; 0000 03D9 		lcd_putsf ("   ");
	__POINTW1FN _0x0,201
	CALL SUBOPT_0x1
; 0000 03DA 
; 0000 03DB 		sprintf (lcd_buffer, "%u", dac_counter);
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,17
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R21
	CALL SUBOPT_0x5
; 0000 03DC 		lcd_gotoxy (26, 3);
	LDI  R30,LOW(26)
	CALL SUBOPT_0x11
; 0000 03DD 		lcd_puts (lcd_buffer);
	CALL SUBOPT_0x14
; 0000 03DE 
; 0000 03DF 		if (dac_counter == 0)
	CPI  R21,0
	BRNE _0xC5
; 0000 03E0 		   {
; 0000 03E1 		    dac_counter_course = 0;
	CLT
	BLD  R15,1
; 0000 03E2 
; 0000 03E3 			lcd_gotoxy (29, 3); //  
	LDI  R30,LOW(29)
	CALL SUBOPT_0x11
; 0000 03E4 			lcd_putsf ("\xd9");
	__POINTW1FN _0x0,160
	CALL SUBOPT_0x1
; 0000 03E5 			};
_0xC5:
; 0000 03E6 
; 0000 03E7 		if (dac_counter == 255)
	CPI  R21,255
	BRNE _0xC6
; 0000 03E8 		   {
; 0000 03E9 			dac_counter_course = 1;
	SET
	BLD  R15,1
; 0000 03EA 
; 0000 03EB 			lcd_gotoxy (29, 3); //  
	LDI  R30,LOW(29)
	CALL SUBOPT_0x11
; 0000 03EC 			lcd_putsf ("\xda");
	__POINTW1FN _0x0,158
	CALL SUBOPT_0x1
; 0000 03ED 			};
_0xC6:
; 0000 03EE 
; 0000 03EF 		if (dac_counter_course)
	SBRS R15,1
	RJMP _0xC7
; 0000 03F0 		   {
; 0000 03F1 		    dac_counter--;
	SUBI R21,1
; 0000 03F2 		    }
; 0000 03F3 		else {
	RJMP _0xC8
_0xC7:
; 0000 03F4 		      dac_counter++;
	SUBI R21,-1
; 0000 03F5 		      };
_0xC8:
; 0000 03F6 
; 0000 03F7 		//  ADC
; 0000 03F8 		for (j = 0; j < 4; j++)
	LDI  R16,LOW(0)
_0xCA:
	CPI  R16,4
	BRSH _0xCB
; 0000 03F9 	       {
; 0000 03FA 			adc_data [j] = __adc_n_read(j);
	CALL SUBOPT_0x1C
	MOVW R26,R28
	ADD  R30,R26
	ADC  R31,R27
	PUSH R31
	PUSH R30
	ST   -Y,R16
	RCALL ___adc_n_read
	POP  R26
	POP  R27
	ST   X,R30
; 0000 03FB 			};
	SUBI R16,-1
	RJMP _0xCA
_0xCB:
; 0000 03FC 
; 0000 03FD 	    for (j = 0; j < 4; j++)
	LDI  R16,LOW(0)
_0xCD:
	CPI  R16,4
	BRSH _0xCE
; 0000 03FE 	        {
; 0000 03FF 	         lcd_gotoxy (17, j); // ADC
	LDI  R30,LOW(17)
	ST   -Y,R30
	ST   -Y,R16
	CALL _lcd_gotoxy
; 0000 0400 	         lcd_putsf ("   ");
	__POINTW1FN _0x0,201
	CALL SUBOPT_0x1
; 0000 0401 	         sprintf (lcd_buffer, "%u", adc_data [j]);
	CALL SUBOPT_0x12
	__POINTW1FN _0x0,17
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x1C
	MOVW R26,R28
	ADIW R26,4
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	CALL SUBOPT_0x5
; 0000 0402 	         lcd_gotoxy (17, j);
	LDI  R30,LOW(17)
	ST   -Y,R30
	ST   -Y,R16
	CALL _lcd_gotoxy
; 0000 0403 	         lcd_puts (lcd_buffer);
	CALL SUBOPT_0x14
; 0000 0404 	         };
	SUBI R16,-1
	RJMP _0xCD
_0xCE:
; 0000 0405 		//---------------------------------------------------------
; 0000 0406 		};
	RJMP _0x4B
; 0000 0407  }
_0xCF:
	RJMP _0xCF
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.EQU __sm_adc_noise_red=0x02
	.SET power_ctrl_reg=smcr
	#endif

	.CSEG
_putchar:
_0x2000006:
	LDS  R30,192
	ANDI R30,LOW(0x20)
	BREQ _0x2000006
	LD   R30,Y
	STS  198,R30
	JMP  _0x20C0008
__put_G100:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000016
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000018
	__CPWRN 16,17,2
	BRLO _0x2000019
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	ST   X+,R30
	ST   X,R31
_0x2000018:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0x2000019:
	RJMP _0x200001A
_0x2000016:
	LDD  R30,Y+6
	ST   -Y,R30
	RCALL _putchar
_0x200001A:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,7
	RET
__print_G100:
	SBIW R28,12
	CALL __SAVELOCR6
	LDI  R17,0
_0x200001B:
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	ADIW R30,1
	STD  Y+24,R30
	STD  Y+24+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x200001D
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x2000021
	CPI  R18,37
	BRNE _0x2000022
	LDI  R17,LOW(1)
	RJMP _0x2000023
_0x2000022:
	CALL SUBOPT_0x2C
_0x2000023:
	RJMP _0x2000020
_0x2000021:
	CPI  R30,LOW(0x1)
	BRNE _0x2000024
	CPI  R18,37
	BRNE _0x2000025
	CALL SUBOPT_0x2C
	RJMP _0x20000DD
_0x2000025:
	LDI  R17,LOW(2)
	LDI  R30,LOW(0)
	STD  Y+17,R30
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000026
	LDI  R16,LOW(1)
	RJMP _0x2000020
_0x2000026:
	CPI  R18,43
	BRNE _0x2000027
	LDI  R30,LOW(43)
	STD  Y+17,R30
	RJMP _0x2000020
_0x2000027:
	CPI  R18,32
	BRNE _0x2000028
	LDI  R30,LOW(32)
	STD  Y+17,R30
	RJMP _0x2000020
_0x2000028:
	RJMP _0x2000029
_0x2000024:
	CPI  R30,LOW(0x2)
	BRNE _0x200002A
_0x2000029:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x200002B
	ORI  R16,LOW(128)
	RJMP _0x2000020
_0x200002B:
	RJMP _0x200002C
_0x200002A:
	CPI  R30,LOW(0x3)
	BRNE _0x200002D
_0x200002C:
	CPI  R18,48
	BRLO _0x200002F
	CPI  R18,58
	BRLO _0x2000030
_0x200002F:
	RJMP _0x200002E
_0x2000030:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x2000020
_0x200002E:
	LDI  R20,LOW(0)
	CPI  R18,46
	BRNE _0x2000031
	LDI  R17,LOW(4)
	RJMP _0x2000020
_0x2000031:
	RJMP _0x2000032
_0x200002D:
	CPI  R30,LOW(0x4)
	BRNE _0x2000034
	CPI  R18,48
	BRLO _0x2000036
	CPI  R18,58
	BRLO _0x2000037
_0x2000036:
	RJMP _0x2000035
_0x2000037:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R20,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0x2000020
_0x2000035:
_0x2000032:
	CPI  R18,108
	BRNE _0x2000038
	ORI  R16,LOW(2)
	LDI  R17,LOW(5)
	RJMP _0x2000020
_0x2000038:
	RJMP _0x2000039
_0x2000034:
	CPI  R30,LOW(0x5)
	BREQ PC+3
	JMP _0x2000020
_0x2000039:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x200003E
	CALL SUBOPT_0x2D
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x2E
	RJMP _0x200003F
_0x200003E:
	CPI  R30,LOW(0x73)
	BRNE _0x2000041
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x2F
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000042
_0x2000041:
	CPI  R30,LOW(0x70)
	BRNE _0x2000044
	CALL SUBOPT_0x2D
	CALL SUBOPT_0x2F
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000042:
	ANDI R16,LOW(127)
	CPI  R20,0
	BREQ _0x2000046
	CP   R20,R17
	BRLO _0x2000047
_0x2000046:
	RJMP _0x2000045
_0x2000047:
	MOV  R17,R20
_0x2000045:
	LDI  R20,LOW(0)
	LDI  R30,LOW(0)
	STD  Y+16,R30
	LDI  R19,LOW(0)
	RJMP _0x2000048
_0x2000044:
	CPI  R30,LOW(0x64)
	BREQ _0x200004B
	CPI  R30,LOW(0x69)
	BRNE _0x200004C
_0x200004B:
	ORI  R16,LOW(4)
	RJMP _0x200004D
_0x200004C:
	CPI  R30,LOW(0x75)
	BRNE _0x200004E
_0x200004D:
	LDI  R30,LOW(10)
	STD  Y+16,R30
	SBRS R16,1
	RJMP _0x200004F
	__GETD1N 0x3B9ACA00
	CALL SUBOPT_0x24
	LDI  R17,LOW(10)
	RJMP _0x2000050
_0x200004F:
	CALL SUBOPT_0x28
	CALL SUBOPT_0x24
	LDI  R17,LOW(5)
	RJMP _0x2000050
_0x200004E:
	CPI  R30,LOW(0x58)
	BRNE _0x2000052
	ORI  R16,LOW(8)
	RJMP _0x2000053
_0x2000052:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2000091
_0x2000053:
	LDI  R30,LOW(16)
	STD  Y+16,R30
	SBRS R16,1
	RJMP _0x2000055
	__GETD1N 0x10000000
	CALL SUBOPT_0x24
	LDI  R17,LOW(8)
	RJMP _0x2000050
_0x2000055:
	__GETD1N 0x1000
	CALL SUBOPT_0x24
	LDI  R17,LOW(4)
_0x2000050:
	CPI  R20,0
	BREQ _0x2000056
	ANDI R16,LOW(127)
	RJMP _0x2000057
_0x2000056:
	LDI  R20,LOW(1)
_0x2000057:
	SBRS R16,1
	RJMP _0x2000058
	CALL SUBOPT_0x2D
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	ADIW R26,4
	CALL __GETD1P
	RJMP _0x20000DE
_0x2000058:
	SBRS R16,2
	RJMP _0x200005A
	CALL SUBOPT_0x2D
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	ADIW R26,4
	CALL __GETW1P
	CALL __CWD1
	RJMP _0x20000DE
_0x200005A:
	CALL SUBOPT_0x2D
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	ADIW R26,4
	CALL __GETW1P
	CLR  R22
	CLR  R23
_0x20000DE:
	__PUTD1S 12
	SBRS R16,2
	RJMP _0x200005C
	LDD  R26,Y+15
	TST  R26
	BRPL _0x200005D
	__GETD1S 12
	CALL __ANEGD1
	__PUTD1S 12
	LDI  R30,LOW(45)
	STD  Y+17,R30
_0x200005D:
	LDD  R30,Y+17
	CPI  R30,0
	BREQ _0x200005E
	SUBI R17,-LOW(1)
	SUBI R20,-LOW(1)
	RJMP _0x200005F
_0x200005E:
	ANDI R16,LOW(251)
_0x200005F:
_0x200005C:
	MOV  R19,R20
_0x2000048:
	SBRC R16,0
	RJMP _0x2000060
_0x2000061:
	CP   R17,R21
	BRSH _0x2000064
	CP   R19,R21
	BRLO _0x2000065
_0x2000064:
	RJMP _0x2000063
_0x2000065:
	SBRS R16,7
	RJMP _0x2000066
	SBRS R16,2
	RJMP _0x2000067
	ANDI R16,LOW(251)
	LDD  R18,Y+17
	SUBI R17,LOW(1)
	RJMP _0x2000068
_0x2000067:
	LDI  R18,LOW(48)
_0x2000068:
	RJMP _0x2000069
_0x2000066:
	LDI  R18,LOW(32)
_0x2000069:
	CALL SUBOPT_0x2C
	SUBI R21,LOW(1)
	RJMP _0x2000061
_0x2000063:
_0x2000060:
_0x200006A:
	CP   R17,R20
	BRSH _0x200006C
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x200006D
	ANDI R16,LOW(251)
	LDD  R30,Y+17
	ST   -Y,R30
	CALL SUBOPT_0x2E
	CPI  R21,0
	BREQ _0x200006E
	SUBI R21,LOW(1)
_0x200006E:
	SUBI R17,LOW(1)
	SUBI R20,LOW(1)
_0x200006D:
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL SUBOPT_0x2E
	CPI  R21,0
	BREQ _0x200006F
	SUBI R21,LOW(1)
_0x200006F:
	SUBI R20,LOW(1)
	RJMP _0x200006A
_0x200006C:
	MOV  R19,R17
	LDD  R30,Y+16
	CPI  R30,0
	BRNE _0x2000070
_0x2000071:
	CPI  R19,0
	BREQ _0x2000073
	SBRS R16,3
	RJMP _0x2000074
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x20000DF
_0x2000074:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x20000DF:
	ST   -Y,R30
	CALL SUBOPT_0x2E
	CPI  R21,0
	BREQ _0x2000076
	SUBI R21,LOW(1)
_0x2000076:
	SUBI R19,LOW(1)
	RJMP _0x2000071
_0x2000073:
	RJMP _0x2000077
_0x2000070:
_0x2000079:
	CALL SUBOPT_0x30
	CALL __DIVD21U
	MOV  R18,R30
	CPI  R18,10
	BRLO _0x200007B
	SBRS R16,3
	RJMP _0x200007C
	SUBI R18,-LOW(55)
	RJMP _0x200007D
_0x200007C:
	SUBI R18,-LOW(87)
_0x200007D:
	RJMP _0x200007E
_0x200007B:
	SUBI R18,-LOW(48)
_0x200007E:
	SBRC R16,4
	RJMP _0x2000080
	CPI  R18,49
	BRSH _0x2000082
	CALL SUBOPT_0x20
	__CPD2N 0x1
	BRNE _0x2000081
_0x2000082:
	RJMP _0x2000084
_0x2000081:
	CP   R20,R19
	BRSH _0x20000E0
	CP   R21,R19
	BRLO _0x2000087
	SBRS R16,0
	RJMP _0x2000088
_0x2000087:
	RJMP _0x2000086
_0x2000088:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000089
_0x20000E0:
	LDI  R18,LOW(48)
_0x2000084:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x200008A
	ANDI R16,LOW(251)
	LDD  R30,Y+17
	ST   -Y,R30
	CALL SUBOPT_0x2E
	CPI  R21,0
	BREQ _0x200008B
	SUBI R21,LOW(1)
_0x200008B:
_0x200008A:
_0x2000089:
_0x2000080:
	CALL SUBOPT_0x2C
	CPI  R21,0
	BREQ _0x200008C
	SUBI R21,LOW(1)
_0x200008C:
_0x2000086:
	SUBI R19,LOW(1)
	CALL SUBOPT_0x30
	CALL __MODD21U
	__PUTD1S 12
	LDD  R30,Y+16
	CALL SUBOPT_0x20
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __DIVD21U
	CALL SUBOPT_0x24
	CALL SUBOPT_0x21
	CALL __CPD10
	BREQ _0x200007A
	RJMP _0x2000079
_0x200007A:
_0x2000077:
	SBRS R16,0
	RJMP _0x200008D
_0x200008E:
	CPI  R21,0
	BREQ _0x2000090
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x2E
	RJMP _0x200008E
_0x2000090:
_0x200008D:
_0x2000091:
_0x200003F:
_0x20000DD:
	LDI  R17,LOW(0)
_0x2000020:
	RJMP _0x200001B
_0x200001D:
	CALL __LOADLOCR6
	ADIW R28,26
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	ST   -Y,R17
	ST   -Y,R16
	MOVW R26,R28
	CALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+2,R30
	STD  Y+2+1,R31
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,4
	POP  R15
	RET

	.CSEG
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
    lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable1=2
    .equ __lcd_enable2=3
    .equ __lcd_busy_flag=7

	.CSEG
__lcd_delay_G102:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    ldi   r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
    in    r26,__lcd_port
    lds   r27,__en1_msk
__lcd_busy:
	RCALL __lcd_delay_G102
    or    r26,r27
    out   __lcd_port,r26          ;EN=1
	RCALL __lcd_delay_G102
    in    r30,__lcd_pin
    andi  r26,0xf3
    out   __lcd_port,r26          ;EN=0
	RCALL __lcd_delay_G102
    or    r26,r27
    out   __lcd_port,r26          ;EN=1
	CALL __lcd_delay_G102
    andi  r26,0xf3
    out   __lcd_port,r26          ;EN=0
	CALL __lcd_delay_G102
    sbrc  r30,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G102:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    or    r26,r30
    out   __lcd_port,r26          ;EN=1
	CALL __lcd_delay_G102
    andi  r26,0xf3
    out   __lcd_port,r26          ;EN=0
	CALL __lcd_delay_G102
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    ldi   r26,0xff                ;set as output
    out   __lcd_direction,r26
    lds   r30,__en1_msk
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G102
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G102
    sbi   __lcd_port,__lcd_rd     ;RD=1
	JMP  _0x20C0007
__lcd_read_nibble_G102:
    in    r27,__lcd_port
    lds   r30,__en1_msk
    or    r27,r30
    out   __lcd_port,r27          ;EN=1
	CALL __lcd_delay_G102
    in    r30,__lcd_pin           ;read
    andi  r27,0xf3
    out   __lcd_port,r27          ;EN=0
	CALL __lcd_delay_G102
    andi  r30,0xf0
	RET
_lcd_read_byte0_G102:
	CALL __lcd_delay_G102
	RCALL __lcd_read_nibble_G102
    mov   r26,r30
	RCALL __lcd_read_nibble_G102
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	ST   -Y,R17
	LDI  R30,LOW(4)
	STS  __en1_msk,R30
	LDD  R26,Y+1
	CPI  R26,LOW(0x2)
	BRLO _0x2040003
	LDI  R30,LOW(8)
	STS  __en1_msk,R30
_0x2040003:
	LDD  R30,Y+2
	SUBI R30,-LOW(128)
	MOV  R17,R30
	LDD  R30,Y+1
	ANDI R30,LOW(0x1)
	BREQ _0x2040004
	ORI  R17,LOW(64)
_0x2040004:
	CALL __lcd_ready
	ST   -Y,R17
	CALL __lcd_write_data
	LDD  R30,Y+2
	STS  __lcd_x,R30
	LDD  R30,Y+1
	STS  __lcd_y,R30
	LDD  R17,Y+0
	JMP  _0x20C0003
_lcd_clear1:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	RET
_lcd_clear:
	LDI  R30,LOW(8)
	STS  __en1_msk,R30
	RCALL _lcd_clear1
	LDI  R30,LOW(4)
	STS  __en1_msk,R30
	RCALL _lcd_clear1
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	LDS  R26,__lcd_x
	CPI  R26,LOW(0x29)
	BRLO _0x2040005
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x2040005:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	RJMP _0x20C0007
_lcd_puts:
	ST   -Y,R17
_0x2040006:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2040008
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2040006
_0x2040008:
	LDD  R17,Y+0
	JMP  _0x20C0003
_lcd_putsf:
	ST   -Y,R17
_0x2040009:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x204000B
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2040009
_0x204000B:
	LDD  R17,Y+0
	JMP  _0x20C0003
__long_delay:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G102:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    ldi   r26,0xff                ;set as output
    out   __lcd_direction,r26
    lds   r30,__en1_msk
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G102
    sbi   __lcd_port,__lcd_rd     ;RD=1
_0x20C0007:
_0x20C0008:
	ADIW R28,1
	RET
_lcd_init1_G102:
	CALL SUBOPT_0x31
	CALL SUBOPT_0x31
	CALL SUBOPT_0x31
	RCALL __long_delay
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G102
	RCALL __long_delay
	LDI  R30,LOW(40)
	CALL SUBOPT_0x32
	LDI  R30,LOW(4)
	CALL SUBOPT_0x32
	LDI  R30,LOW(133)
	CALL SUBOPT_0x32
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G102
	CPI  R30,LOW(0x5)
	BRNE _0x20C0006
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	RJMP _0x20C0005
_lcd_init:
    cbi   __lcd_port,__lcd_enable1 ;EN1=0
    cbi   __lcd_port,__lcd_enable2 ;EN2=0
    cbi   __lcd_port,__lcd_rs      ;RS=0
	LDI  R30,LOW(4)
	STS  __en1_msk,R30
	RCALL _lcd_init1_G102
	CPI  R30,0
	BREQ _0x20C0006
	LDI  R30,LOW(8)
	STS  __en1_msk,R30
	RCALL _lcd_init1_G102
	CPI  R30,0
	BRNE _0x204000E
_0x20C0006:
	LDI  R30,LOW(0)
	RET
_0x204000E:
	CALL _lcd_clear
_0x20C0005:
	LDI  R30,LOW(1)
	RET

	.CSEG
_rtc_init:
	LDD  R30,Y+2
	ANDI R30,LOW(0x3)
	STD  Y+2,R30
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x2060003
	LDD  R30,Y+2
	ORI  R30,0x10
	STD  Y+2,R30
_0x2060003:
	LD   R30,Y
	CPI  R30,0
	BREQ _0x2060004
	LDD  R30,Y+2
	ORI  R30,0x80
	STD  Y+2,R30
_0x2060004:
	CALL SUBOPT_0x33
	LDI  R30,LOW(7)
	CALL SUBOPT_0x34
	RJMP _0x20C0002
_rtc_get_time:
	CALL SUBOPT_0x33
	LDI  R30,LOW(0)
	CALL SUBOPT_0x35
	ST   -Y,R30
	CALL _bcd2bin
	LD   R26,Y
	LDD  R27,Y+1
	CALL SUBOPT_0x36
	ST   -Y,R30
	CALL _bcd2bin
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RJMP _0x20C0004
_rtc_set_time:
	CALL SUBOPT_0x33
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_write
	LD   R30,Y
	CALL SUBOPT_0x37
	CALL SUBOPT_0x34
	RJMP _0x20C0001
_rtc_get_date:
	CALL SUBOPT_0x33
	LDI  R30,LOW(4)
	CALL SUBOPT_0x35
	ST   -Y,R30
	CALL _bcd2bin
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL SUBOPT_0x36
	ST   -Y,R30
	CALL _bcd2bin
	LD   R26,Y
	LDD  R27,Y+1
_0x20C0004:
	ST   X,R30
	CALL _i2c_stop
	ADIW R28,6
	RET
_rtc_set_date:
	CALL SUBOPT_0x33
	LDI  R30,LOW(4)
	CALL SUBOPT_0x34
	CALL SUBOPT_0x37
	ST   -Y,R30
	CALL _i2c_write
	LD   R30,Y
_0x20C0001:
	ST   -Y,R30
	CALL _bin2bcd
_0x20C0002:
	ST   -Y,R30
	CALL SUBOPT_0xB
_0x20C0003:
	ADIW R28,3
	RET

	.CSEG

	.CSEG
_bcd2bin:
    ld   r30,y
    swap r30
    andi r30,0xf
    mov  r26,r30
    lsl  r26
    lsl  r26
    add  r30,r26
    lsl  r30
    ld   r26,y+
    andi r26,0xf
    add  r30,r26
    ret
_bin2bcd:
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret

	.DSEG
__en1_msk:
	.BYTE 0x1
_lcd_buffer:
	.BYTE 0x28
_rom_code:
	.BYTE 0x24
_rx_buffer:
	.BYTE 0x8
_tx_data:
	.BYTE 0x8
_tx_a:
	.BYTE 0x8
_no_sensor:
	.BYTE 0x1
_sensor_crc_error:
	.BYTE 0x1
_sensor_type:
	.BYTE 0x1
_no_t_sensor:
	.BYTE 0x1
_n_no_t_sensor:
	.BYTE 0x1
_temp_buffer:
	.BYTE 0x10
_p_S1010024:
	.BYTE 0x2
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x0:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 19 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x1:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x2:
	SUBI R30,-LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _rtc_get_time

;OPTIMIZER ADDED SUBROUTINE, CALLED 12 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x4:
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:67 WORDS
SUBOPT_0x5:
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x6:
	ST   -Y,R30
	LDD  R30,Y+5
	ST   -Y,R30
	CALL _lcd_gotoxy
	MOVW R30,R28
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(9)
	LDI  R31,HIGH(9)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(11)
	LDI  R31,HIGH(11)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _rtc_get_date

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x8:
	ST   -Y,R30
	LDD  R30,Y+5
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	MOVW R30,R28
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	CALL _i2c_start
	LDI  R30,LOW(144)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xB:
	CALL _i2c_write
	JMP  _i2c_stop

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xC:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xD:
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _i2c_read

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	LDI  R30,LOW(0)
	ST   -Y,R30
	JMP  _i2c_read

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(_rx_buffer)
	LDI  R31,HIGH(_rx_buffer)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _w1_dow_crc8
	__GETB2MN _rx_buffer,7
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x10:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	JMP  _w1_dow_crc8

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x11:
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 21 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x13:
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x14:
	LDI  R30,LOW(_lcd_buffer)
	LDI  R31,HIGH(_lcd_buffer)
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x15:
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x16:
	LDI  R26,LOW(9)
	MUL  R19,R26
	MOVW R30,R0
	SUBI R30,LOW(-_rom_code)
	SBCI R31,HIGH(-_rom_code)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x17:
	MOV  R30,R19
	LDI  R26,LOW(1)
	CALL __LSLB12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x18:
	MOV  R30,R19
	SUBI R30,-LOW(1)
	RJMP SUBOPT_0x5

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x19:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R19
	CALL _lcd_gotoxy
	RJMP SUBOPT_0x12

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1A:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1B:
	LDS  R30,_no_sensor
	ST   -Y,R30
	CALL ___byte_length
	MOV  R0,R30
	LDS  R26,_n_no_t_sensor
	MOV  R30,R10
	SUB  R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1C:
	MOV  R30,R16
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1D:
	__GETB1MN _tx_data,2
	ORI  R30,0x10
	__PUTB1MN _tx_data,2
	LDD  R30,Y+12
	COM  R30
	STD  Y+12,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:22 WORDS
SUBOPT_0x1E:
	LDD  R30,Y+12
	LSR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	__PUTD1S 8
	__GETD2S 8
	__GETD1N 0x2710
	CALL __MULD12U
	__PUTD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:35 WORDS
SUBOPT_0x1F:
	__PUTD1S 8
	LDD  R30,Y+18
	CLR  R31
	CLR  R22
	CLR  R23
	__PUTD1S 4
	__GETD2S 4
	__GETD1N 0x2710
	CALL __MULD12U
	__PUTD1S 4
	LDD  R30,Y+19
	__GETD2S 4
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __DIVD21U
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x20:
	__GETD2S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x21:
	__GETD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x22:
	LDI  R30,LOW(15)
	ST   -Y,R30
	ST   -Y,R19
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x23:
	__POINTW1FN _0x0,14
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES, CODE SIZE REDUCTION:17 WORDS
SUBOPT_0x24:
	__PUTD1S 8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x25:
	MOV  R30,R19
	LDI  R26,LOW(_temp_buffer)
	LDI  R27,HIGH(_temp_buffer)
	LDI  R31,0
	CALL __LSLW2
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETD1P
	RJMP SUBOPT_0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x26:
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x27:
	ST   -Y,R30
	ST   -Y,R19
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x28:
	__GETD1N 0x2710
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x29:
	LDI  R26,0
	SBIC 0x5,6
	LDI  R26,1
	LDI  R30,LOW(1)
	EOR  R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x2A:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP SUBOPT_0xC

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2B:
	LDS  R30,_sensor_crc_error
	LDS  R26,_no_sensor
	OR   R30,R26
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x2C:
	ST   -Y,R18
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,21
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G100

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x2D:
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	SBIW R30,4
	STD  Y+22,R30
	STD  Y+22+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x2E:
	LDD  R30,Y+21
	LDD  R31,Y+21+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,21
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G100

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x2F:
	LDD  R26,Y+22
	LDD  R27,Y+22+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x30:
	RCALL SUBOPT_0x21
	__GETD2S 12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x31:
	CALL __long_delay
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_init_write_G102

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x32:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __long_delay

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x33:
	CALL _i2c_start
	LDI  R30,LOW(208)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x34:
	ST   -Y,R30
	CALL _i2c_write
	LDD  R30,Y+2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x35:
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_start
	LDI  R30,LOW(209)
	RJMP SUBOPT_0xD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x36:
	ST   X,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _i2c_read
	ST   -Y,R30
	CALL _bcd2bin
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
	RJMP SUBOPT_0xE

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x37:
	ST   -Y,R30
	RCALL _bin2bcd
	ST   -Y,R30
	CALL _i2c_write
	LDD  R30,Y+1
	ST   -Y,R30
	RJMP _bin2bcd


	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,20
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,40
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xBB8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

_w1_init:
	clr  r30
	cbi  __w1_port,__w1_bit
	sbi  __w1_port-1,__w1_bit
	__DELAY_USW 0x5A0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x38
	sbis __w1_port-2,__w1_bit
	ret
	__DELAY_USW 0xE4
	sbis __w1_port-2,__w1_bit
	inc  r30
	__DELAY_USW 0x492
	ret

__w1_read_bit:
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x8
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x2C
	clc
	sbic __w1_port-2,__w1_bit
	sec
	ror  r30
	__DELAY_USW 0xF0
	ret

__w1_write_bit:
	clt
	sbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x8
	sbrc r23,0
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x34
	sbic __w1_port-2,__w1_bit
	rjmp __w1_write_bit0
	sbrs r23,0
	rjmp __w1_write_bit1
	ret
__w1_write_bit0:
	sbrs r23,0
	ret
__w1_write_bit1:
	__DELAY_USW 0xE1
	cbi  __w1_port-1,__w1_bit
	__DELAY_USB 0x14
	set
	ret

_w1_read:
	ldi  r22,8
	__w1_read0:
	rcall __w1_read_bit
	dec  r22
	brne __w1_read0
	ret

_w1_write:
	ldi  r22,8
	ld   r23,y+
	clr  r30
__w1_write0:
	rcall __w1_write_bit
	brtc __w1_write1
	ror  r23
	dec  r22
	brne __w1_write0
	inc  r30
__w1_write1:
	ret

_w1_search:
	push r20
	push r21
	clr  r1
	clr  r20
	ld   r26,y
	ldd  r27,y+1
__w1_search0:
	mov  r0,r1
	clr  r1
	rcall _w1_init
	tst  r30
	breq __w1_search7
	ldd  r30,y+2
	st   -y,r30
	rcall _w1_write
	ldi  r21,1
__w1_search1:
	cp   r21,r0
	brsh __w1_search6
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search2
	rcall __w1_read_bit
	sbrc r30,7
	rjmp __w1_search3
	rcall __sel_bit
	and  r24,r25
	brne __w1_search3
	mov  r1,r21
	rjmp __w1_search3
__w1_search2:
	rcall __w1_read_bit
__w1_search3:
	rcall __sel_bit
	and  r24,r25
	ldi  r23,0
	breq __w1_search5
__w1_search4:
	ldi  r23,1
__w1_search5:
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search6:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search9
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search8
__w1_search7:
	mov  r30,r20
	pop  r21
	pop  r20
	adiw r28,3
	ret
__w1_search8:
	set
	rcall __set_bit
	rjmp __w1_search4
__w1_search9:
	rcall __w1_read_bit
	sbrs r30,7
	rjmp __w1_search10
	rjmp __w1_search11
__w1_search10:
	cp   r21,r0
	breq __w1_search12
	mov  r1,r21
__w1_search11:
	clt
	rcall __set_bit
	clr  r23
	rcall __w1_write_bit
	rjmp __w1_search13
__w1_search12:
	set
	rcall __set_bit
	ldi  r23,1
	rcall __w1_write_bit
__w1_search13:
	inc  r21
	cpi  r21,65
	brlt __w1_search1
	rcall __w1_read_bit
	rol  r30
	rol  r30
	andi r30,1
	adiw r26,8
	st   x,r30
	sbiw r26,8
	inc  r20
	tst  r1
	breq __w1_search7
	ldi  r21,9
__w1_search14:
	ld   r30,x
	adiw r26,9
	st   x,r30
	sbiw r26,8
	dec  r21
	brne __w1_search14
	rjmp __w1_search0

__sel_bit:
	mov  r30,r21
	dec  r30
	mov  r22,r30
	lsr  r30
	lsr  r30
	lsr  r30
	clr  r31
	add  r30,r26
	adc  r31,r27
	ld   r24,z
	ldi  r25,1
	andi r22,7
__sel_bit0:
	breq __sel_bit1
	lsl  r25
	dec  r22
	rjmp __sel_bit0
__sel_bit1:
	ret

__set_bit:
	rcall __sel_bit
	brts __set_bit2
	com  r25
	and  r24,r25
	rjmp __set_bit3
__set_bit2:
	or   r24,r25
__set_bit3:
	st   z,r24
	ret

_w1_dow_crc8:
	clr  r30
	ld   r24,y
	tst  r24
	breq __w1_dow_crc83
	ldi  r22,0x18
	ldd  r26,y+1
	ldd  r27,y+2
__w1_dow_crc80:
	ldi  r25,8
	ld   r31,x+
__w1_dow_crc81:
	mov  r23,r31
	eor  r23,r30
	ror  r23
	brcc __w1_dow_crc82
	eor  r30,r22
__w1_dow_crc82:
	ror  r30
	lsr  r31
	dec  r25
	brne __w1_dow_crc81
	dec  r24
	brne __w1_dow_crc80
__w1_dow_crc83:
	adiw r28,3
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__SUBD12:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	SBC  R23,R25
	RET

__ORD12:
	OR   R30,R26
	OR   R31,R27
	OR   R22,R24
	OR   R23,R25
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__LNEGB1:
	TST  R30
	LDI  R30,1
	BREQ __LNEGB1F
	CLR  R30
__LNEGB1F:
	RET

__MULD12U:
	MUL  R23,R26
	MOV  R23,R0
	MUL  R22,R27
	ADD  R23,R0
	MUL  R31,R24
	ADD  R23,R0
	MUL  R30,R25
	ADD  R23,R0
	MUL  R22,R26
	MOV  R22,R0
	ADD  R23,R1
	MUL  R31,R27
	ADD  R22,R0
	ADC  R23,R1
	MUL  R30,R24
	ADD  R22,R0
	ADC  R23,R1
	CLR  R24
	MUL  R31,R26
	MOV  R31,R0
	ADD  R22,R1
	ADC  R23,R24
	MUL  R30,R27
	ADD  R31,R0
	ADC  R22,R1
	ADC  R23,R24
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	ADC  R22,R24
	ADC  R23,R24
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__CPD21:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R25,R23
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
